<?php
/*
Plugin Name: Tweet This
Plugin URI: http://richardxthripp.thripp.com/tweet-this/
Description: Adds a "Tweet This Post" link to every post, shortens URLs, and can automatically tweet posts using OAuth. Includes Wickett Twitter Widget.
Author: Richard X. Thripp
Version: 1.7.6
Author URI: http://richardxthripp.thripp.com/
Text Domain: tweet-this
*/


/**
 * Tweet This is a plugin for WordPress 2.7 - 3.0.1 and WordPress MU.
 * Copyright 2008 - 2010  Richard X. Thripp  (email: richardxthripp@thripp.com)
 * Released under Version 2 of the GNU General Public License as published by
 * the Free Software Foundation, or, at your option, any later version.
 */


/**
 * This is Tweet This v1.7.6, build 032, released 2010-09-17.
 */


/**
 * Definitions.
 */
if(!defined('WP_CONTENT_URL'))
	define('WP_CONTENT_URL', get_option('siteurl') . '/wp-content');
if(!defined('WP_CONTENT_DIR'))
	define('WP_CONTENT_DIR', ABSPATH . 'wp-content');
if(!defined('WP_PLUGIN_URL'))
	define('WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins');
if(!defined('WP_PLUGIN_DIR'))
	define('WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins');
define('TT_DIR', 'tweet-this');
define('TT_ABSPATH', WP_PLUGIN_DIR . '/' . TT_DIR . '/');
define('TT_URLPATH', WP_PLUGIN_URL . '/' . TT_DIR . '/');
define('TT_VERSION', '1.7.6');
define('TT_DB_VERSION', '1.0');
define('TT_BUILD', '032');
define('TT_CONFIG', TT_ABSPATH . 'tt-config.php');
define('TT_OPTIONS', TT_ABSPATH . 'lib/tt-options.php');
define('TT_OAUTH', TT_ABSPATH . 'lib/twitteroauth.php');
define('TT_OAUTH_BASE', TT_ABSPATH . 'lib/OAuth.php');
define('TT_OAUTH_SPECIAL', TT_ABSPATH . 'lib/twitteroauth-special.php');
define('TT_OAUTH_BASE_SPECIAL', TT_ABSPATH . 'lib/OAuth-special.php');
define('TT_JSON', TT_ABSPATH . 'lib/json.php');
define('TT_WP_JSON', ABSPATH . WPINC . '/class-json.php');
define('TT_API_POST_STATUS', 'http://twitter.com/statuses/update.json');
define('TT_ADJIX_LEN', 21);
define('TT_B2LME_LEN', 20);
define('TT_BITLY_LEN', 20);
define('TT_CUSTOM_LEN', 26);
define('TT_ISGD_LEN', 18);
define('TT_LOCAL_LEN', strlen(str_replace('https://', 'http://',
	get_bloginfo('url'))) + 8);
define('TT_METAMARK_LEN', 20);
define('TT_SNIPURL_LEN', 25);
define('TT_SUPR_LEN', 19);
define('TT_TCO_LEN', 19);
define('TT_TH8US_LEN', 19);
define('TT_TINYURL_LEN', 26);
define('TT_TWEETBURNER_LEN', 22);
if(version_compare($GLOBALS['wp_version'], '2.0', '<')) {
	global $wpdb; global $table_prefix;
	$wpdb->rxtt = $table_prefix . 'tweet_this_scheduled';
	define('TT_FILE_LOC', '?page=tweet-this/tweet-this.php');}
else {	global $wpdb; $wpdb->rxtt = $wpdb->prefix . 'tweet_this_scheduled';
	define('TT_FILE_LOC', '?page=tweet-this.php');}
if(file_exists(TT_CONFIG)) require_once(TT_CONFIG);


/**
 * JSON functions.
 * Based on: http://wordpress.org/extend/plugins/wp-to-twitter/
 * WP to Twitter  Copyright 2008 - 2010  Joe Dolson  http://www.joedolson.com/
 */
if(!class_exists('Services_JSON')) {
	if(version_compare($wp_version, '2.9', '<'))
		require_once(TT_JSON);
	else require_once(TT_WP_JSON);}
if(!function_exists('json_encode')) {
	function json_encode($data) {
		$json = new Services_JSON();
		return($json->encode($data));}}
if(!function_exists('json_decode')) {
	function json_decode($data) {
		$json = new Services_JSON(SERVICES_JSON_LOOSE_TYPE);
		return($json->decode($data));}}


/**
 * Do not edit these here, but rather, in the tt-config.php file.
 */
if(!defined('TT_PREFIX'))
	define('TT_PREFIX', '<div class="tweetthis" style="text-align:' .
	tt_option('tt_alignment') . ';"><p>');
if(!defined('TT_SUFFIX'))
	define('TT_SUFFIX', '</p></div>');
if(!defined('TT_SEPARATOR'))
	define('TT_SEPARATOR', ' ');
if(!defined('TT_OVERRIDE_OPTIONS'))
	define('TT_OVERRIDE_OPTIONS', true);
if(!defined('TT_HIDE_MENU'))
	define('TT_HIDE_MENU', false);
if(!defined('TT_SPECIAL_OPTIONS'))
	define('TT_SPECIAL_OPTIONS', '');


/**
 * Easy access to Tweet This options stored in an array in wp_options table.
 */
function tt_option($key) {
	if(defined('TT_OVERRIDE_OPTIONS') && defined('TT_SPECIAL_OPTIONS') &&
		TT_OVERRIDE_OPTIONS == true && TT_SPECIAL_OPTIONS != '' &&
		unserialize(TT_SPECIAL_OPTIONS) != false)
			$options = unserialize(TT_SPECIAL_OPTIONS);
	else $options = get_option('tweet_this_settings');
	if($key == 'nw') {
		if($options['tt_new_window'] == 'true')
			return 'target="_blank" ';
		else return '';
	}
	elseif($key == 'nf') {
		if($options['tt_nofollow'] == 'true')
			return 'rel="nofollow" ';
		else return '';
	}
	elseif($key == 'tt_alignment') {
		if($options['tt_alignment'] == '' ||
			($options['tt_alignment'] != 'left' &&
			$options['tt_alignment'] != 'right' &&
			$options['tt_alignment'] != 'center'))
				return 'left';
		else return $options['tt_alignment'];
	}
	elseif($key == 'tt_twitter')
		return stripslashes(htmlentities($options['tt_auto_display']));
	elseif($key == 'tt_twitter_text')
		return stripslashes(htmlentities($options['tt_tweet_text']));
	elseif($key == 'tt_twitter_link_text')
		return stripslashes(htmlentities($options['tt_link_text']));
	elseif($key == 'tt_twitter_title_text')
		return stripslashes(htmlentities($options['tt_title_text']));
	elseif($key == 'tt_css' && $options['tt_css'] ==
		'a.[LINK_CLASS]{text-decoration:none;border:0;}')
		return 'img.[IMG_CLASS]{border:0;}';
	else return stripslashes(htmlentities($options[$key]));
}


/**
 * Same as tt_option($key).
 */
function get_tt_option($key) {
	return tt_option($key);
}


/**
 * Connects to external URL via curl and returns file.
 */
function tt_read_file($url) {
	if(ini_get('allow_url_fopen') == 1 ||
		strtolower(ini_get('allow_url_fopen')) == 'on') {
		$file = @file_get_contents($url);
		if($file == false) {
			$handle = @fopen($url, 'r');
			$file = @fread($handle, 4096);
			@fclose($handle);
			}
	} else {
		if(function_exists('curl_init')) {
			$ch = curl_init($url);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
			$file = curl_exec($ch);
			curl_close($ch);
			}
		}
	if($file != false && $file != '')
		return $file;
}


/**
 * Same as tt_read_file($url).
 */
function get_tt_read_file($url) {
	return tt_read_file($url);
}


/**
 * Retrieves the shortened URL for a post, taking into account the user's
 * settings. No arguments. Works on the current post.
 * Must be used within the loop.
 */
function get_tweet_this_short_url($longurl = '', $post_id = '',
	$return = true, $admin = false, $service = '') {
	if($admin != true) {
		global $id;
		if($post_id == '') $post_id = $id;
		$cached_url = get_post_meta($post_id, 'tweet_this_url', true);}
	if($longurl != '') $purl = $longurl;
	else $purl = get_permalink();
	$purl = str_replace('https://', 'http://', $purl);
	$sn_purl = rawurlencode($purl);
	$purl = urlencode($purl);
	if($cached_url && $cached_url != 'getnew' && $admin != true)
		return $cached_url;
	else {
		if($admin == true) {
			$get_service = tt_option('tt_admin_url_service');
			if($get_service == 'same') $get_service =
				tt_option('tt_url_service');}
		else $get_service = tt_option('tt_url_service');
		if($service != '') $u = $service;
		else $u = str_replace('snurl', 'snipurl', $get_service);
		if((ini_get('allow_url_fopen') != 1 &&
		strtolower(ini_get('allow_url_fopen')) != 'on' &&
		!function_exists('curl_init')) ||
		($u == 'adjix' && tt_option('tt_adjix_api_key') == '') ||
		($u == 'snipurl' && (!function_exists('curl_init') ||
		tt_option('tt_snipurl_username') == '' ||
		tt_option('tt_snipurl_api_key') == '')) ||
		($u == 'tweetburner' && !function_exists('curl_init')))
			$u = 'local';
		if(($u == '' || $u == 'same' || $u == 'local') &&
			$admin == true) $u = 'bit.ly';
		switch($u) {
		case 'adjix': {
			if(tt_option('tt_ad_vu') != 'false')
				$ad_vu = '&ultraShort=y';
			$url = tt_read_file('http://api.adjix.com/shrinkLink' .
				'?url=' . $purl . '&partnerID=' .
				tt_option('tt_adjix_api_key') . $ad_vu);}
			break;
		case 'b2l.me':
			$url = tt_read_file('http://b2l.me/api.php?alias=' .
				'&url=' . $purl);
			break;
		case 'bit.ly': {
			if(tt_option('tt_bitly_username') != '' &&
			tt_option('tt_bitly_api_key') != '') {
				$decoded = json_decode(tt_read_file('http://' .
				'api.bit.ly/v3/shorten?longUrl=' . $purl .
				'&login=' . tt_option('tt_bitly_username') .
				'&apiKey=' . tt_option('tt_bitly_api_key') .
				'&format=json'), 'true');
				if($decoded['status_code'] == '200')
					$url = $decoded['data']['url'];
				else $url = tt_read_file('http://bit.ly/' .
					'api?url=' . $purl);}
			else $url = tt_read_file('http://bit.ly/api?url=' .
				$purl);
			if(tt_option('tt_j_mp') == 'true')
				$url = str_replace('http://bit.ly/',
				'http://j.mp/', $url);}
			break;
		case 'is.gd':
			$url = tt_read_file('http://is.gd/api.php?longurl=' .
				$purl);
			break;
		case 'metamark':
			$url = tt_read_file('http://metamark.net/api/rest/' .
				'simple?long_url=' . $purl);
			break;
		case 'snipurl': {
			$sn_api = 'http://snipurl.com/site/getsnip';
			$sn_post = 'sniplink=' . $sn_purl . '&snipuser=' .
			tt_option('tt_snipurl_username') . '&snipapi=' .
			tt_option('tt_snipurl_api_key') . '&snipformat=simple';
			$ch = curl_init($sn_api);
			curl_setopt($ch, CURLOPT_URL, $sn_api);
			curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $sn_post);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$url = curl_exec($ch); curl_close($ch);
			if(tt_option('tt_snipurl_domain') == 'snipr.com')
				$url = str_replace('http://snipurl.com/',
				'http://snipr.com/', $url);
			elseif(tt_option('tt_snipurl_domain') == 'snurl.com')
				$url = str_replace('http://snipurl.com/',
				'http://snurl.com/', $url);
			elseif(tt_option('tt_snipurl_domain') == 'sn.im')
				$url = str_replace('http://snipurl.com/',
				'http://sn.im/', $url);
			elseif(tt_option('tt_snipurl_domain') == 'cl.lk')
				$url = str_replace('http://snipurl.com/',
				'http://cl.lk/', $url);}
			break;
		case 'su.pr': {
			if(tt_option('tt_supr_username') != '' &&
				tt_option('tt_supr_api_key') != '')
				$supr_api = '&login=' .
				tt_option('tt_supr_username') . '&apiKey=' .
				tt_option('tt_supr_api_key');
			$url = tt_read_file('http://su.pr/api/simpleshorten?' .
				'url=' . $purl . $supr_api);}
			break;
		case 'th8.us':
			$url = tt_read_file('http://th8.us/api.php?url=' .
				$purl . '&client=Tweet+This+v' . TT_VERSION .
				'&format=simple');
			break;
		case 'tinyurl':
			$url = tt_read_file('http://tinyurl.com/' .
				'api-create.php?url=' . $purl);
			break;
		case 'tweetburner': {
			$tw_post = 'link[url]=' . $purl;
			$ch = curl_init('http://tweetburner.com/links');
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $tw_post);
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
			$url = curl_exec($ch); curl_close($ch);}
			break;
		case 'local':
		default:
			$url = get_bloginfo('url') . '/?p=' . $post_id;
			break;
		case 'custom':
			$url = tt_read_file(str_replace('[LONGURL]',
			$purl, tt_option('tt_custom_url_service')));
			break;
		}
	// Tweetburner URLs cannot be accessed with the www subdomain.
	// It's not safe to replace http:// with www. outright because if
	// the blog already has the www subdomain you will get www.www.
		if(tt_option('tt_url_www') == 'true' && $u != 'tweetburner') {
			$url =	str_replace('http://', 'www.',
				str_replace('http://www.', 'www.', $url));
			}
	// If short URL > 30 characters, is error, or is malformed, discard.
		if($u != 'local' && $u != 'custom' && $admin != true &&
		(strlen($url) > 30 || strtolower($url) == 'error' ||
		$url == 'www.' || $url == 'http://' || $url == ''))
				$url = get_bloginfo('url') . '/?p=' . $post_id;
		if(tt_option('tt_30') == 'true' && strlen($purl) < 30 &&
		$admin != true) {
			$url = $purl;
			if(tt_option('tt_url_www') == 'true')
				$url =	str_replace('http://', 'www.',
					str_replace('http://www.', 'www.',
					$url));
			}
		if($admin != true) {
			if($cached_url == 'getnew')
				update_post_meta($post_id, 'tweet_this_url',
				$url, 'getnew');
			else add_post_meta($post_id, 'tweet_this_url',
			$url, true);
		}
		if($return != false) return $url;
	}
}


/**
 * Echoes the above function for convenience.
 */
function tweet_this_short_url() {
	echo	get_tweet_this_short_url();
}


/**
 * Parses the post title. Truncates with an ellipse if the title is too long.
 */
function get_tweet_this_trim_title($title = '', $tweet_text = '',
	$service = 'twitter') {
	if($title == '') $title = get_the_title();
	if($tweet_text == '') {
		if($service == 'twitter-share')
			$tweet_text = tt_option('tt_twitter_share_text');
		else	$tweet_text = tt_option('tt_tweet_text');}
	$title = @html_entity_decode($title, ENT_COMPAT, 'UTF-8');
	if($service == 'twitter-share') {
		if(tt_option('tt_twitter_share_via') == '[BLANK]')
			$via_len = 0;
		else $via_len = strlen(tt_option('tt_twitter_share_via'));
		if($via_len != 0) $via_len += 6;}
	else $via_len = 0;
	$tt_len = max((strlen($tweet_text) - 12), 1);
	if($service == 'twitter-share') $url_len = constant('TT_TCO_LEN');
	else $url_len = get_tt_url_service_len();
	$lens = $tt_len + $url_len + $via_len;
	if(strlen($title) > (140 - $lens))
		$title = preg_replace('/(\%[0-9A-Z]{2})+(\.\.\.)?$/U', '...',
			substr($title, 0, (137 - $lens)) . '...');
	return urlencode($title);
}


/**
 * Echoes the above function for convenience.
 */
function tweet_this_trim_title() {
	echo	get_tweet_this_trim_title();
}


/**
 * Returns the text for the Tweet This link, which can be specified in
 * Settings > Tweet This. Default is "Tweet This Post."
 */
function get_tweet_this_link_text($link_text = '', $service = 'twitter') {
	if($link_text == '') {
		if($service == 'twitter' || $service == 'twitter-share' ||
		$service == '') {
			if(tt_option('tt_link_text') == '')
				$link_text = __('Tweet This Post',
					'tweet-this');
			else $link_text = tt_option('tt_link_text');
		}
		elseif($service == 'plurk') {
			if(tt_option('tt_plurk_link_text') == '')
				$link_text = __('Plurk This Post',
					'tweet-this');
			else $link_text = tt_option('tt_plurk_link_text');
		}
		elseif($service == 'buzz') {
			if(tt_option('tt_buzz_link_text') == '')
				$link_text = __('Buzz This Post',
					'tweet-this');
			else $link_text = tt_option('tt_buzz_link_text');
		}
		elseif($service == 'delicious') {
			if(tt_option('tt_delicious_link_text') == '')
				$link_text = __('Delicious', 'tweet-this');
			else $link_text = tt_option('tt_delicious_link_text');
		}
		elseif($service == 'digg') {
			if(tt_option('tt_digg_link_text') == '')
				$link_text = __('Digg This Post',
					'tweet-this');
			else $link_text = tt_option('tt_digg_link_text');
		}
		elseif($service == 'facebook') {
			if(tt_option('tt_facebook_link_text') == '')
				$link_text = __('Facebook', 'tweet-this');
			else $link_text = tt_option('tt_facebook_link_text');
		}
		elseif($service == 'myspace') {
			if(tt_option('tt_myspace_link_text') == '')
				$link_text = __('MySpace', 'tweet-this');
			else $link_text = tt_option('tt_myspace_link_text');
		}
		elseif($service == 'ping') {
			if(tt_option('tt_ping_link_text') == '')
				$link_text = __('Ping This Post',
					'tweet-this');
			else $link_text = tt_option('tt_ping_link_text');
		}
		elseif($service == 'reddit') {
			if(tt_option('tt_reddit_link_text') == '')
				$link_text = __('Reddit', 'tweet-this');
			else $link_text = tt_option('tt_reddit_link_text');
		}
		elseif($service == 'su') {
			if(tt_option('tt_su_link_text') == '')
				$link_text = __('Stumble This Post',
					'tweet-this');
			else $link_text = tt_option('tt_su_link_text');
		}
	}
	$link_s = array('[TITLE]', '[TITLE_SHARE]', '[URL]');
	$link_r = array(get_the_title(), get_tweet_this_trim_title(
		get_the_title(), $link_text, 'twitter-share'),
		get_tweet_this_short_url());
	$link_text = str_replace($link_s, $link_r, $link_text);
	return $link_text;
}


/**
 * Echoes the above function for convenience.
 */
function tweet_this_link_text($link_text = '', $service = 'twitter') {
	echo	get_tweet_this_link_text($link_text, $service);
}


/**
 * Returns the pop-up title attribute for the Tweet This link, which can be
 * specified in Settings > Tweet This. Default is "Post to Twitter."
 */
function get_tweet_this_title_text($title_text = '', $service = 'twitter') {
	if($title_text == '') {
		if($service == 'twitter' || $service == 'twitter-share' ||
		$service == '') {
			if(tt_option('tt_title_text') == '')
				$title_text = __('Post to Twitter',
					'tweet-this');
			else $title_text = tt_option('tt_title_text');
		}
		elseif($service == 'plurk') {
			if(tt_option('tt_plurk_title_text') == '')
				$title_text = __('Post to Plurk',
					'tweet-this');
			else $title_text = tt_option('tt_plurk_title_text');
		}
		elseif($service == 'buzz') {
			if(tt_option('tt_buzz_title_text') == '')
				$title_text = __('Post to Yahoo Buzz',
					'tweet-this');
			else $title_text = tt_option('tt_buzz_title_text');
		}
		elseif($service == 'delicious') {
			if(tt_option('tt_delicious_title_text') == '')
				$title_text = __('Post to Delicious',
					'tweet-this');
			else $title_text =
				tt_option('tt_delicious_title_text');
		}
		elseif($service == 'digg') {
			if(tt_option('tt_digg_title_text') == '')
				$title_text = __('Post to Digg',
					'tweet-this');
			else $title_text = tt_option('tt_digg_title_text');
		}
		elseif($service == 'facebook') {
			if(tt_option('tt_facebook_title_text') == '')
				$title_text = __('Post to Facebook',
					'tweet-this');
			else $title_text = tt_option('tt_facebook_title_text');
		}
		elseif($service == 'myspace') {
			if(tt_option('tt_myspace_title_text') == '')
				$title_text = __('Post to MySpace',
					'tweet-this');
			else $title_text = tt_option('tt_myspace_title_text');
		}
		elseif($service == 'ping') {
			if(tt_option('tt_ping_title_text') == '')
				$title_text = __('Post to Ping.fm',
					'tweet-this');
			else $title_text = tt_option('tt_ping_title_text');
		}
		elseif($service == 'reddit') {
			if(tt_option('tt_reddit_title_text') == '')
				$title_text = __('Post to Reddit',
					'tweet-this');
			else $title_text = tt_option('tt_reddit_title_text');
		}
		elseif($service == 'su') {
			if(tt_option('tt_su_title_text') == '')
				$title_text = __('Post to StumbleUpon',
					'tweet-this');
			else $title_text = tt_option('tt_su_title_text');
		}
	}
	$title_s = array('[TITLE]', '[TITLE_SHARE]', '[URL]');
	$title_r = array(get_the_title(), get_tweet_this_trim_title(
		get_the_title(), $link_text, 'twitter-share'),
		get_tweet_this_short_url());
	$title_text = str_replace($title_s, $title_r, $title_text);
	return $title_text;
}


/**
 * Echoes the above function for convenience.
 */
function tweet_this_title_text($title_text = '', $service = 'twitter') {
	echo	get_tweet_this_title_text($title_text, $service);
}


/**
 * Determines whether the Tweet This link can be displayed on the current post.
 * If true, this function returns what you put in. If false, it returns blank.
 * This function is complicated because the user can specify that links be
 * hidden on posts and/or only shown on single posts, and this can be
 * over-ridden for individual posts and pages.
 */
function tt_display_limits($item) {
	global $preview;
	global $post;
	if((!$preview && $post->post_status != 'draft') ||
	tt_option('tt_url_service') == 'local') {
		if(tt_option('tt_limit_to_posts') == 'true') {
			if(tt_option('tt_limit_to_single') == 'true') {
				if(is_single())
					return $item;
			} else {
				if(!is_page())
					return $item;
				}
			}
		if(tt_option('tt_limit_to_single') == 'true') {
			if(tt_option('tt_limit_to_posts') == 'true') {
				if(is_single())
					return $item;
			} else {
				if(is_singular())
					return $item;
			}
		}
	if(tt_option('tt_limit_to_posts') != 'true' &&
		tt_option('tt_limit_to_single') != 'true')
		return $item;
	}
}


/**
 * Same as tt_display_limits($item).
 */
function get_tt_display_limits($item) {
	return tt_display_limits($item);
}


/**
 * Generates the Twitter URL; the direct URL to tweet a post to Twitter,
 * taking into account the user's settings.
 */
function get_tweet_this_url($tweet_text = '', $service = '', $longurl = '',
	$title = '', $post_id = '', $auto = false) {
	if($service == 'twitter')
		$path = 'http://twitter.com/home/?status=';
	elseif($service == 'twitter-share')
		$path = 'http://twitter.com/share?url=';
	elseif($service == 'plurk')
		$path = 'http://plurk.com/?status=';
	else	$path = 'http://twitter.com/home/?status=';
	if($tweet_text == '') {
		if($service == 'twitter') {
			if(tt_option('tt_tweet_text') == '')
				$tweet_text = '[TITLE] [URL]';
			else $tweet_text = tt_option('tt_tweet_text');}
		elseif($service == 'twitter-share') {
			if(tt_option('tt_twitter_share_text') == '')
				$tweet_text = '[TITLE_SHARE]';
			else $tweet_text = tt_option('tt_twitter_share_text');}
		elseif($service == 'plurk') {
			if(tt_option('tt_plurk_text') == '')
				$tweet_text = '[TITLE] [URL]';
			else $tweet_text = tt_option('tt_plurk_text');}
		else {	if(tt_option('tt_tweet_text') == '')
				$tweet_text = '[TITLE] [URL]';
			else $tweet_text = tt_option('tt_tweet_text');}
	}
	if($service == 'twitter-share') $url = get_permalink();
	else $url = get_tweet_this_short_url($longurl, $post_id);
	$tweet_s = array('[TITLE]', '[TITLE_SHARE]', '[URL]', ' ');
	$tweet_r = array(get_tweet_this_trim_title($title, $tweet_text),
		get_tweet_this_trim_title($title, $tweet_text,
		'twitter-share'), $url, '+');
	$tweet_text = str_replace($tweet_s, $tweet_r, $tweet_text);
	if($service == 'twitter-share') {
		if($tweet_text == '[BLANK]' || $tweet_text == false)
			$text = '';
		elseif($tweet_text != '')
			$text = '&text=' . $tweet_text;
		else $text = '';
		if(tt_option('tt_twitter_share_via') == '[BLANK]')
			$via = '';
		elseif(tt_option('tt_twitter_share_via') != '')
			$via = '&via=' . tt_option('tt_twitter_share_via');
		else $via = '&via=tweetthisplugin';
		if(tt_option('tt_twitter_share_rel') == '[BLANK]')
			$rel = '';
		elseif(tt_option('tt_twitter_share_rel') != '')
			$rel = '&related=' . str_replace(array(' ', ','),
				array('%20', '%2C'),
				tt_option('tt_twitter_share_rel'));
		else $rel = '&related=richardxthripp%2Ctweetthisplugin';
		$final = $path . $url . $text . $via . $rel;
	}
	else $final = $path . $tweet_text;
	if($auto == true) return $tweet_text;
	else	return tt_display_limits(str_replace('#', '%23', $final));
}


/**
 * Echoes the above function for convenience.
 */
function tweet_this_url($tweet_text = '', $service = '', $longurl = '',
	$title = '', $post_id = '', $auto = false) {
	echo	get_tweet_this_url($tweet_text, $service, $longurl, $title,
		$post_id, $auto);
}


/**
 * This is the core function of the plugin. Generates the Tweet This links,
 * including images, text, title attributes, and new window and nofollow
 * preferences. This function can also be manually placed into the theme with
 * the arguments customized to your liking, and "Insert Tweet This links"
 * disabled in the options (so they don't appear twice).
 */
function get_tweet_this($service = 'twitter', $tweet_text = '',
	$link_text = '', $title_text = '', $icon_file = '', $a_class = '',
	$img_class = '', $img_alt = '') {
	if($a_class == '') {
		if(tt_option('tt_link_css_class') == '')
			$a_class = 'tt';
		else $a_class = tt_option('tt_link_css_class');
		}
	if($img_class == '') {
		if(tt_option('tt_img_css_class') == '')
			$img_class = 'nothumb';
		else $img_class = tt_option('tt_img_css_class');
		}
	$url = get_tweet_this_url($tweet_text, $service);
	$get_title = get_tweet_this_title_text($title_text, $service);
	if($get_title == '[BLANK]') $title = '';
	else $title = ' title="' . $get_title . '"';
	$link = get_tweet_this_link_text($link_text, $service);
	if($service == 'twitter' || $service == 'twitter-share' ||
	$service == '') {
		if($img_alt == '')
			$img_alt = __('Post to Twitter', 'tweet-this');
		if($icon_file == '') {
			if(tt_option('tt_twitter_icon') == '')
				$icon_file = 'tt-twitter.png';
			else $icon_file = tt_option('tt_twitter_icon');
			}
		}
	if($service == 'plurk') {
		if($img_alt == '')
			$img_alt = __('Post to Plurk', 'tweet-this');
		if($icon_file == '') {
			if(tt_option('tt_plurk_icon') == '')
				$icon_file = 'tt-plurk.png';
			else $icon_file = tt_option('tt_plurk_icon');
			}
		}
	if($service == 'buzz') {
		if($img_alt == '')
			$img_alt = __('Post to Yahoo Buzz', 'tweet-this');
		if($icon_file == '') {
			if(tt_option('tt_buzz_icon') == '')
				$icon_file = 'tt-buzz.png';
			else $icon_file = tt_option('tt_buzz_icon');
			}
		$url = 'http://buzz.yahoo.com/submit?submitUrl=' .
			get_permalink() . '&amp;submitHeadline=' .
			get_tweet_this_trim_title();
		}
	if($service == 'delicious') {
		if($img_alt == '')
			$img_alt = __('Post to Delicious', 'tweet-this');
		if($icon_file == '') {
			if(tt_option('tt_delicious_icon') == '')
				$icon_file = 'tt-delicious.png';
			else $icon_file = tt_option('tt_delicious_icon');
			}
		$url = 'http://delicious.com/post?url=' . get_permalink() .
			'&amp;title=' . get_tweet_this_trim_title();
		}
	if($service == 'digg') {
		if($img_alt == '')
			$img_alt = __('Post to Digg', 'tweet-this');
		if($icon_file == '') {
			if(tt_option('tt_digg_icon') == '')
				$icon_file = 'tt-digg.png';
			else $icon_file = tt_option('tt_digg_icon');
			}
		$url = 'http://digg.com/submit?url=' . get_permalink() .
			'&amp;title=' . get_tweet_this_trim_title();
		}
	if($service == 'facebook') {
		if($img_alt == '')
			$img_alt = __('Post to Facebook', 'tweet-this');
		if($icon_file == '') {
			if(tt_option('tt_facebook_icon') == '')
				$icon_file = 'tt-facebook.png';
			else $icon_file = tt_option('tt_facebook_icon');
			}
		$url = 'http://www.facebook.com/share.php?u=' .
			get_permalink() . '&amp;t=' .
			get_tweet_this_trim_title();
		}
	if($service == 'myspace') {
		if($img_alt == '')
			$img_alt = __('Post to MySpace', 'tweet-this');
		if($icon_file == '') {
			if(tt_option('tt_myspace_icon') == '')
				$icon_file = 'tt-myspace.png';
			else $icon_file = tt_option('tt_myspace_icon');
			}
		$url = 'http://www.myspace.com/Modules/PostTo/Pages/' .
			'?l=3&amp;u=' . get_permalink() . '&amp;t=' .
			get_tweet_this_trim_title();
		}
	if($service == 'ping') {
		if($img_alt == '')
			$img_alt = __('Post to Ping.fm', 'tweet-this');
		if($icon_file == '') {
			if(tt_option('tt_ping_icon') == '')
				$icon_file = 'tt-ping.png';
			else $icon_file = tt_option('tt_ping_icon');
			}
		$url = 'http://ping.fm/ref/?method=microblog&amp;title=' .
			get_tweet_this_trim_title() . '&amp;link=' .
			get_permalink();
		}
	if($service == 'reddit') {
		if($img_alt == '')
			$img_alt = __('Post to Reddit', 'tweet-this');
		if($icon_file == '') {
			if(tt_option('tt_reddit_icon') == '')
				$icon_file = 'tt-reddit.png';
			else $icon_file = tt_option('tt_reddit_icon');
			}
		$url = 'http://reddit.com/submit?url=' . get_permalink() .
			'&amp;title=' . get_tweet_this_trim_title();
		}
	if($service == 'su') {
		if($img_alt == '')
			$img_alt = __('Post to StumbleUpon', 'tweet-this');
		if($icon_file == '') {
			if(tt_option('tt_su_icon') == '')
				$icon_file = 'tt-su.png';
			else $icon_file = tt_option('tt_su_icon');
			}
		$url = 'http://stumbleupon.com/submit?url=' . get_permalink() .
			'&amp;title=' . get_tweet_this_trim_title();
		}
	$icon = TT_URLPATH . 'icons/' . $icon_file;
	if($service == 'twitter' || $service == '')
		$style = ' style="margin:0;"';
	else 	$style = ' style="margin:0 0 0 2px;"';
	if($icon_file != 'noicon')
		$item = '<a ' . tt_option('nw') . tt_option('nf') .
			'class="' . $a_class . '" href="' . $url .
			'"' . $title . '><img class="' .
			$img_class . '" src="' . $icon . '" alt="' .
			$img_alt . '"' . $style . ' /></a>';
	if($link != '[BLANK]')
		$item .= ' <a ' . tt_option('nw') . tt_option('nf') .
			'class="' . $a_class . '" href="' . $url .
			'"' . $title . '>' . $link . '</a>';
	if(($service == 'twitter' || $service == '') &&
		$icon_file == 'textbox') {
		$textbox = tt_option('tt_textbox_size');
		if($textbox == '')
			$textbox = '60';
		if($link == '[BLANK]')
			$link = __('Tweet This Post', 'tweet-this');
		$item =	'<form action="' . get_bloginfo('wpurl') .
		'/index.php" method="post" id="tt_twitter_box"><fieldset>
		<input type="text" id="tt_twitter_box_text" ' .
		'name="tt_twitter_box_text" class="tt_twitter_box" size="' .
		$textbox . '" value="' . urldecode(html_entity_decode((
		str_replace('http://twitter.com/home/?status=', '', $url)))) .
		'" onchange="ttCharCount();" onclick="ttCharCount();" ' .
		'onkeyup="ttCharCount();" maxlength="140" />
		<script type="text/javascript">
		//<![CDATA[
		function ttCharCount() {
			var count = document.getElementById' .
				'("tt_twitter_box_text").value.length;
			document.getElementById("tt_char_count").innerHTML =' .
				' "<strong>" + (140 - count) + "</strong>"' .
				' + "' . __(' character(s) remaining',
				'tweet-this') . '";
		}
		setTimeout("ttCharCount();", 500);
		document.getElementById("tt_twitter_box").' .
			'setAttribute("autocomplete", "off");
		//]]></script><br /><input type="submit" ' .
		'id="tt_twitter_box_submit" name="tt_twitter_box_submit" ' .
		'value="' . $link . '" class="button-primary" ' .
		'style="margin-top:5px;margin-bottom:-5px;" /> ' .
		'<span id="tt_char_count"></span></fieldset><input type=' .
		'"hidden" name="ttaction" value="tt_twitter_box" /></form>';
	}
	return tt_display_limits($item);
}


/**
 * Echoes the above function for convenience.
 */
function tweet_this($service = 'twitter', $tweet_text = '', $link_text = '',
	$title_text = '', $icon_file = '', $a_class = '', $img_class = '',
	$img_alt = '') {
	echo	get_tweet_this($service, $tweet_text, $link_text, $title_text,
		$icon_file, $a_class, $img_class, $img_alt);
}


/**
 * Tweet This options on post edit screen.
 */
function tt_post_options() {
	global $post;
	$tt_auto = get_post_meta($post->ID, 'tt_auto_tweet', true);
	$tt_auto_text = get_post_meta($post->ID, 'tt_auto_tweet_text', true);
	$tt_http_code = get_post_meta($post->ID, 'tt_http_code', true);
	$tt_tweeted = get_post_meta($post->ID, 'tt_tweeted', true);
	echo	'<div class="postbox"><h3>' . __('Tweet This', 'tweet-this') .
		'</h3><div class="inside"><p>';
	if(tt_option('tt_app_consumer_key') == '' ||
		tt_option('tt_app_consumer_secret') == '' ||
		tt_option('tt_oauth_token') == '' ||
		tt_option('tt_oauth_token_secret') == '') {
		echo '<strong>'; printf(__('Please enter your Twitter OAuth ' .
		'keys under <a target="_blank" href="%1$s/wp-admin/options-' .
		'general.php%2$s">Settings &gt; Tweet This &gt; Automatic ' .
		'Tweeting</a>, or uncheck "Enable automatic tweeting on ' .
		'posts" and "Enable automatic tweeting on pages" to remove ' .
		'this box.', 'tweet-this'), get_bloginfo('url'),
		constant('TT_FILE_LOC')); echo '</strong>';}
	elseif($tt_tweeted != 'false' && $tt_tweeted != '') {
		if(substr($tt_tweeted, 0, 7) == 'http://')
			$link = ': <a href="' . $tt_tweeted .
			'" target="_blank">' . $tt_tweeted . '</a>. ';
		else $link = '. ';
		echo '<input type="hidden" name="tt_auto_tweet" value=' .
		'"false" /><input type="hidden" name="tt_auto_tweet_text" ' .
		'value="' . htmlentities($tt_auto_text) . '" /><strong>' .
		'<font color="green">' . __('Tweet published',
		'tweet-this') . $link . __('To allow a retweet, delete the ' .
		'tt_tweeted custom field and resave the post.', 'tweet-this') .
		'</font></strong>';}
	elseif($post->post_status == 'private')
		echo	'<strong>' . __('Cannot tweet a private post.',
			'tweet-this') . '</strong>';
	else {
		if(trim($tt_http_code) != '' && trim($tt_http_code) != '200') {
			echo '<strong>';
			printf(__('Tweet failed. Twitter returned <font ' .
			'color="red">HTTP %1$s</font>. Check your OAuth ' .
			'settings and re-save this post to try again.',
			'tweet-this'), $tt_http_code);
			echo '</strong></p><p>';
		}
		echo	'<script type="text/javascript">
		//<![CDATA[
		function ttCharCount() {
			var count = document.getElementById' .
				'("tt_auto_tweet_text").value.length;
			var count_title = document.getElementById' .
				'("title").value.length;
			document.getElementById("tt_char_count")' .
				'.innerHTML = "<strong>" + (140 - count - ' .
				'count_title - ' . get_tt_url_service_len() .
				') + "</strong>&nbsp;" + "' .
				__('character(s)&nbsp;remaining', 'tweet-this') .
				'";
		}
		setTimeout("ttCharCount();", 500);
		document.getElementById("tt_twitter_box").' .
			'setAttribute("autocomplete", "off");
		ttCharCount();
		//]]></script>
		<label for="tt_auto_tweet" class="selectit">
			<input type="hidden" name="tt_auto_tweet" value=' .
			'"false" /><input name="tt_auto_tweet" id="tt_auto_' .
			'tweet" type="checkbox"';
		if($tt_auto == 'true' || (tt_option('tt_auto_tweet') == 'true'
			&& $tt_auto != 'false' && $post->post_type != 'page' &&
			$post->post_status != 'publish') ||
			(tt_option('tt_auto_tweet_pages') == 'true' &&
			$tt_auto != 'false' && $post->post_type == 'page' &&
			$post->post_status != 'publish'))
			echo	' checked="checked"';
		echo	' value="true" /> ' . __('Send to Twitter',
			'tweet-this') . '</label> <input type="text" ' .
			'name="tt_auto_tweet_text" ' .
			'id="tt_auto_tweet_text" size="75" value="';
		if($tt_auto_text != '')
			echo	htmlentities($tt_auto_text);
		elseif(tt_option('tt_auto_tweet_text') != '')
			echo	htmlentities(tt_option('tt_auto_tweet_text'));
		else echo	__('New blog post', 'tweet-this') .
				': [TITLE] [URL]';
		echo	'" onchange="ttCharCount();" ' .
			'onclick="ttCharCount();" onkeyup="ttCharCount();" ' .
			'maxlength="140" /> <span id="tt_char_count"></span>';
	}
	echo	'</p></div></div>';
}


/**
 * Saves options on post edit screen.
 */
function tt_store_post_options($post_id, $post = false) {
	$post = get_post($post_id);
	if(!$post || ($post->post_type != 'page' &&
		tt_option('tt_auto_tweet_display') == 'false') ||
		($post->post_type == 'page' &&
		tt_option('tt_auto_tweet_display_pages') == 'false'))
			return false;
	$tt_auto_save = get_post_meta($post_id, 'tt_auto_tweet', true);
	if($tt_auto_save == '' && $post->post_type != 'page')
		$tt_auto_save = tt_option('tt_auto_tweet');
	elseif($tt_auto_save == '' && $post->post_type == 'page')
		$tt_auto_save = tt_option('tt_auto_tweet_pages');
	if($tt_auto_save == '') $tt_auto_save = 'false';
	if($_POST['tt_auto_tweet'] == 'true') $tt_auto_post = 'true';
	elseif($_POST['tt_auto_tweet'] == 'false') $tt_auto_post = 'false';
	else	$tt_auto_post = $tt_auto_save;
	update_post_meta($post_id, 'tt_auto_tweet', $tt_auto_post);
	$tt_auto_text_post = $_POST['tt_auto_tweet_text'];
	$tt_auto_text_save =
		get_post_meta($post_id, 'tt_auto_tweet_text', true);
	if($tt_auto_text_post == $tt_auto_text_save && $tt_auto_text_post != ''
		&& $tt_auto_text_save != '') $save_text = false;
	elseif($tt_auto_text_post == '') {
		if($tt_auto_text_save == '')
			$tt_auto_text_save = tt_option('tt_auto_tweet_text');
		$tt_auto_text_post = $tt_auto_text_save;
		$save_text = true;
	}
	elseif($tt_auto_text_save == '') $save_text = true;
	if($tt_auto_text_post == '') $tt_auto_text_post =
		__('New blog post', 'tweet-this') . ': [TITLE] [URL]';
	update_post_meta($post_id, 'tt_auto_tweet_text', $tt_auto_text_post);
}


/**
 * Handles automatic tweeting of posts.
 */
function tt_auto_tweet($post_id) {
	$post = get_post($post_id);
	$tt_auto = get_post_meta($post_id, 'tt_auto_tweet', true);
	$tt_auto_text = get_post_meta($post_id, 'tt_auto_tweet_text', true);
	$tt_tweeted = get_post_meta($post_id, 'tt_tweeted', true);
	if($tt_auto == 'true' || $tt_auto == 'false')
		$tweet_auto = $tt_auto;
	elseif(tt_option('tt_auto_tweet') != '')
		$tweet_auto = tt_option('tt_auto_tweet');
	else $tweet_auto = 'false';
	if($_POST['tt_auto_tweet'] == 'true')
		$tweet_auto = 'true';
	if($tt_auto_text != '')
		$tweet_text = $tt_auto_text;
	elseif(tt_option('tt_auto_tweet_text') != '')
		$tweet_text = tt_option('tt_auto_tweet_text');
	else $tweet_text = __('New blog post', 'tweet-this') .
		': [TITLE] [URL]';
	if(trim($_POST['tt_auto_tweet_text']) != '')
		$tweet_text = $_POST['tt_auto_tweet_text'];
	if(	($tt_tweeted != 'false' && $tt_tweeted != '') ||
		$tweet_auto == 'false' || !$post ||
		!tt_option('tt_app_consumer_key') ||
		!tt_option('tt_app_consumer_secret') ||
		!tt_option('tt_oauth_token') ||
		!tt_option('tt_oauth_token_secret') ||
		($post->post_type != 'page' &&
		tt_option('tt_auto_tweet_display') == 'false') ||
		($post->post_type == 'page' &&
		tt_option('tt_auto_tweet_display_pages') == 'false'))
			return false;
	else {
		if(tt_option('tt_app_consumer_key') != '' &&
		tt_option('tt_app_consumer_secret') != '' &&
		tt_option('tt_oauth_token') != '' &&
		tt_option('tt_oauth_token_secret') != '') {
			$status = urldecode(get_tweet_this_url($tweet_text,
			'twitter', get_permalink($post_id),
			$post->post_title, $post_id, true));
			$connection = tt_oauth_connection();
			$connection->decode_json = true;
			$data = $connection->post(TT_API_POST_STATUS,
			array('status' => $status, 'source' => 'tweetthis'));
		if($connection->http_code == '200') {
			update_post_meta($post_id, 'tt_tweeted',
				'http://twitter.com/' .
				$data->user->screen_name . '/status/' .
				$data->id);
			delete_post_meta($post_id, 'tt_http_code');}
		else {	update_post_meta($post_id, 'tt_tweeted', 'false');
			update_post_meta($post_id, 'tt_http_code',
				$connection->http_code);}}}
}


/**
 * Inserts the Tweet This links, including the other social networks.
 */
function insert_tweet_this($content) {
	global $id;
	global $preview;
	global $post;
	$tweet_this_hide = get_post_meta($id, 'tweet_this_hide', true);
	if(($tweet_this_hide && $tweet_this_hide != 'false') || (($preview ||
		$post->post_status == 'draft') &&
		tt_option('tt_url_service') != 'local'))
			$content = $content;
	else {
		if(tt_option('tt_auto_display') == 'true' ||
			tt_option('tt_plurk') == 'true' ||
			tt_option('tt_buzz') == 'true' ||
			tt_option('tt_delicious') == 'true' ||
			tt_option('tt_digg') == 'true' ||
			tt_option('tt_facebook') == 'true' ||
			tt_option('tt_digg') == 'true' ||
			tt_option('tt_ping') == 'true' ||
			tt_option('tt_reddit') == 'true' ||
			tt_option('tt_su') == 'true')
				$content .= tt_display_limits(TT_PREFIX);
		if(tt_option('tt_auto_display') == 'true') {
			if(tt_option('tt_twitter_share') == 'true')
				$content .= get_tweet_this('twitter-share');
			else	$content .= get_tweet_this('twitter');
			if(tt_option('tt_twitter_icon') == 'textbox' &&
			(tt_option('tt_plurk') == 'true' ||
			tt_option('tt_buzz') == 'true' ||
			tt_option('tt_delicious') == 'true' ||
			tt_option('tt_digg') == 'true' ||
			tt_option('tt_facebook') == 'true' ||
			tt_option('tt_digg') == 'true' ||
			tt_option('tt_ping') == 'true' ||
			tt_option('tt_reddit') == 'true' ||
			tt_option('tt_su') == 'true'))
				$content .= '<p style="margin:4px;"></p>';
			}
		if(tt_option('tt_plurk') == 'true')
			$content .= TT_SEPARATOR . get_tweet_this('plurk');
		if(tt_option('tt_buzz') == 'true')
			$content .= TT_SEPARATOR . get_tweet_this('buzz');
		if(tt_option('tt_delicious') == 'true')
			$content .= TT_SEPARATOR . get_tweet_this('delicious');
		if(tt_option('tt_digg') == 'true')
			$content .= TT_SEPARATOR . get_tweet_this('digg');
		if(tt_option('tt_facebook') == 'true')
			$content .= TT_SEPARATOR . get_tweet_this('facebook');
		if(tt_option('tt_myspace') == 'true')
			$content .= TT_SEPARATOR . get_tweet_this('myspace');
		if(tt_option('tt_ping') == 'true')
			$content .= TT_SEPARATOR . get_tweet_this('ping');
		if(tt_option('tt_reddit') == 'true')
			$content .= TT_SEPARATOR . get_tweet_this('reddit');
		if(tt_option('tt_su') == 'true')
			$content .= TT_SEPARATOR . get_tweet_this('su');
		if(tt_option('tt_auto_display') == 'true' ||
			tt_option('tt_plurk') == 'true' ||
			tt_option('tt_buzz') == 'true' ||
			tt_option('tt_delicious') == 'true' ||
			tt_option('tt_digg') == 'true' ||
			tt_option('tt_facebook') == 'true' ||
			tt_option('tt_myspace') == 'true' ||
			tt_option('tt_ping') == 'true' ||
			tt_option('tt_reddit') == 'true' ||
			tt_option('tt_su') == 'true')
				$content .= tt_display_limits(TT_SUFFIX);
		$h = array('http://www.', 'http://', 'www.');
		$h2 = array('', '', '');
		global $i;
		$url = str_replace($h, $h2, get_tweet_this_short_url());
	}
	return $content;
}


/**
 * Use this to insert the Tweet This links into your theme manually (return).
 */
function get_tweet_this_manual() {
	remove_filter('the_content', 'insert_tweet_this');
	return insert_tweet_this('');
}


/**
 * Use this to insert the Tweet This links into your theme manually (echo).
 */
function tweet_this_manual() {
	remove_filter('the_content', 'insert_tweet_this');
	echo insert_tweet_this('');
}


/**
 * CSS inserted using the wp_head hook.
 */
function get_tweet_this_css() {
	if(tt_option('tt_css') == '')
	return	'<style type="text/css">img.' . tt_option('tt_img_css_class') .
		'{border:0;}</style>';
	else return	'<style type="text/css">' .
			str_replace(array('[IMG_CLASS]', '[LINK_CLASS]'),
			array(tt_option('tt_img_css_class'),
			tt_option('tt_link_css_class')), tt_option('tt_css')) .
			'</style>';
}


/**
 * Echoes the above function for convenience.
 */
function tweet_this_css() {
	echo get_tweet_this_css();
}


/**
 * Update the options stored in the database when the user changes them.
 */
function update_tt_options() {
	if(isset($_REQUEST['tt']))
		$new_options = $_REQUEST['tt'];
	$booleans = array('tt_30', 'tt_limit_to_single', 'tt_limit_to_posts',
		'tt_url_www', 'tt_auto_display', 'tt_shortlink_filter',
		'tt_plurk', 'tt_buzz', 'tt_delicious', 'tt_digg',
		'tt_facebook', 'tt_myspace', 'tt_ping', 'tt_reddit', 'tt_su',
		'tt_ad_vu', 'tt_j_mp', 'tt_footer', 'tt_ads', 'tt_new_window',
		'tt_nofollow', 'tt_auto_tweet_display',
		'tt_auto_tweet_display_pages', 'tt_auto_tweet',
		'tt_auto_tweet_pages');
	foreach($booleans as $key)
		$new_options[$key] = $new_options[$key] ? 'true' : 'false';

	$new_options['tt_app_consumer_key'] =
		trim($_REQUEST['tt_app_consumer_key']);
	$new_options['tt_app_consumer_secret'] =
		trim($_REQUEST['tt_app_consumer_secret']);
	$new_options['tt_oauth_token'] =
		trim($_REQUEST['tt_oauth_token']);
	$new_options['tt_oauth_token_secret'] =
		trim($_REQUEST['tt_oauth_token_secret']);
	$new_options['tt_adjix_api_key'] =
		trim($new_options['tt_adjix_api_key']);
	$new_options['tt_bitly_username'] =
		trim($new_options['tt_bitly_username']);
	$new_options['tt_bitly_api_key'] =
		trim($new_options['tt_bitly_api_key']);
	$new_options['tt_snipurl_username'] =
		trim($new_options['tt_snipurl_username']);
	$new_options['tt_snipurl_api_key'] =
		trim($new_options['tt_snipurl_api_key']);
	$new_options['tt_supr_username'] =
		trim($new_options['tt_supr_username']);
	$new_options['tt_supr_api_key'] =
		trim($new_options['tt_supr_api_key']);

	if($new_options['tt_twitter_share'] == 'share')
		$new_options['tt_twitter_share'] = 'true';
	else $new_options['tt_twitter_share'] = 'false';

	if(tt_option('tt_url_service') != $new_options['tt_url_service'] ||
		tt_option('tt_url_www') != $new_options['tt_url_www'] ||
		tt_option('tt_30') != $new_options['tt_30'] ||
		tt_option('tt_ad_vu') != $new_options['tt_ad_vu'] ||
		tt_option('tt_j_mp') != $new_options['tt_j_mp'] ||
		tt_option('tt_adjix_api_key') !=
		$new_options['tt_adjix_api_key'] ||
		tt_option('tt_bitly_username') !=
		$new_options['tt_bitly_username'] ||
		tt_option('tt_bitly_api_key') !=
		$new_options['tt_bitly_api_key'] ||
		tt_option('tt_snipurl_username') !=
		$new_options['tt_snipurl_username'] ||
		tt_option('tt_snipurl_api_key') !=
		$new_options['tt_snipurl_api_key'] ||
		tt_option('tt_snipurl_domain') !=
		$new_options['tt_snipurl_domain'] ||
		tt_option('tt_supr_username') !=
		$new_options['tt_supr_username'] ||
		tt_option('tt_supr_api_key') !=
		$new_options['tt_supr_api_key'] ||
		tt_option('tt_custom_url_service') !=
		$new_options['tt_custom_url_service']) {
			global_flush_tt_cache();
			$flush = ' ' . __('URL cache flushed.', 'tweet-this');}

    // FIXME: Check != instead of == to save space.

	if($new_options['tt_link_text'] == __('Tweet This Post', 'tweet-this')
	&& tt_option('tt_link_text') == __('Tweet This Post', 'tweet-this') &&
	$new_options['tt_twitter_icon'] != tt_option('tt_twitter_icon') &&
	($new_options['tt_twitter_icon'] == 'tt-twitter-big1.png' ||
	$new_options['tt_twitter_icon'] == 'tt-twitter-big2.png' ||
	$new_options['tt_twitter_icon'] == 'tt-twitter-big3.png' ||
	$new_options['tt_twitter_icon'] == 'tt-twitter-big4.png' ||
	$new_options['tt_twitter_icon'] == 'tt-twitter-micro3.png' ||
	$new_options['tt_twitter_icon'] == 'tt-twitter-micro4.png' ||
	$new_options['tt_twitter_icon'] == 'tt-twitter5.png' ||
	$new_options['tt_twitter_icon'] == 'tt-twitter6.png' ||
	$new_options['tt_twitter_icon'] == 'de/tt-twitter-big1.png' ||
	$new_options['tt_twitter_icon'] == 'de/tt-twitter-big2.png' ||
	$new_options['tt_twitter_icon'] == 'de/tt-twitter-big3.png' ||
	$new_options['tt_twitter_icon'] == 'de/tt-twitter-big4.png' ||
	$new_options['tt_twitter_icon'] == 'de/tt-twitter-micro3.png' ||
	$new_options['tt_twitter_icon'] == 'de/tt-twitter-micro4.png' ||
	$new_options['tt_twitter_icon'] == 'tt-twitter-micro1.png' ||
	$new_options['tt_twitter_icon'] == 'tt-twitter-micro2.png'))
		$new_options['tt_link_text'] = '[BLANK]';

	if($new_options['tt_plurk_link_text'] ==
	__('Plurk This Post', 'tweet-this') &&
	tt_option('tt_plurk_link_text') ==
	__('Plurk This Post', 'tweet-this') &&
	$new_options['tt_plurk_icon'] != tt_option('tt_plurk_icon') &&
	($new_options['tt_plurk_icon'] == 'tt-plurk-big1.png' ||
	$new_options['tt_plurk_icon'] == 'tt-plurk-big2.png' ||
	$new_options['tt_plurk_icon'] == 'tt-plurk-big3.png' ||
	$new_options['tt_plurk_icon'] == 'tt-plurk-big4.png' ||
	$new_options['tt_plurk_icon'] == 'tt-plurk-micro3.png' ||
	$new_options['tt_plurk_icon'] == 'tt-plurk-micro4.png'))
		$new_options['tt_plurk_link_text'] = '[BLANK]';

	if($new_options['tt_buzz_link_text'] ==
	__('Buzz This Post', 'tweet-this') && tt_option('tt_buzz_link_text') ==
	__('Buzz This Post', 'tweet-this') &&
	$new_options['tt_buzz_icon'] != tt_option('tt_buzz_icon') &&
	($new_options['tt_buzz_icon'] == 'tt-buzz-big1.png' ||
	$new_options['tt_buzz_icon'] == 'tt-buzz-big2.png' ||
	$new_options['tt_buzz_icon'] == 'tt-buzz-big3.png' ||
	$new_options['tt_buzz_icon'] == 'tt-buzz-big4.png' ||
	$new_options['tt_buzz_icon'] == 'tt-buzz-micro3.png' ||
	$new_options['tt_buzz_icon'] == 'tt-buzz-micro4.png'))
		$new_options['tt_buzz_link_text'] = '[BLANK]';

	if($new_options['tt_delicious_link_text'] ==
	__('Post to Delicious', 'tweet-this') &&
	tt_option('tt_delicious_link_text') ==
	__('Post to Delicious', 'tweet-this') &&
	$new_options['tt_delicious_icon'] != tt_option('tt_delicious_icon') &&
	($new_options['tt_delicious_icon'] == 'tt-delicious-big1.png' ||
	$new_options['tt_delicious_icon'] == 'tt-delicious-big2.png' ||
	$new_options['tt_delicious_icon'] == 'tt-delicious-big3.png' ||
	$new_options['tt_delicious_icon'] == 'tt-delicious-big4.png' ||
	$new_options['tt_delicious_icon'] == 'tt-delicious-micro3.png' ||
	$new_options['tt_delicious_icon'] == 'tt-delicious-micro4.png'))
		$new_options['tt_delicious_link_text'] = '[BLANK]';

	if($new_options['tt_digg_link_text'] ==
	__('Digg This Post', 'tweet-this') && tt_option('tt_digg_link_text') ==
	__('Digg This Post', 'tweet-this') &&
	$new_options['tt_digg_icon'] != tt_option('tt_digg_icon') &&
	($new_options['tt_digg_icon'] == 'tt-digg-big1.png' ||
	$new_options['tt_digg_icon'] == 'tt-digg-big2.png' ||
	$new_options['tt_digg_icon'] == 'tt-digg-big3.png' ||
	$new_options['tt_digg_icon'] == 'tt-digg-big4.png' ||
	$new_options['tt_digg_icon'] == 'tt-digg-micro3.png' ||
	$new_options['tt_digg_icon'] == 'tt-digg-micro4.png'))
		$new_options['tt_digg_link_text'] = '[BLANK]';

	if($new_options['tt_facebook_link_text'] ==
	__('Post to Facebook', 'tweet-this') &&
	tt_option('tt_facebook_link_text') ==
	__('Post to Facebook', 'tweet-this') &&
	$new_options['tt_facebook_icon'] != tt_option('tt_facebook_icon') &&
	($new_options['tt_facebook_icon'] == 'tt-facebook-big1.png' ||
	$new_options['tt_facebook_icon'] == 'tt-facebook-big2.png' ||
	$new_options['tt_facebook_icon'] == 'tt-facebook-big3.png' ||
	$new_options['tt_facebook_icon'] == 'tt-facebook-big4.png' ||
	$new_options['tt_facebook_icon'] == 'tt-facebook-micro3.png' ||
	$new_options['tt_facebook_icon'] == 'tt-facebook-micro4.png'))
		$new_options['tt_facebook_link_text'] = '[BLANK]';

	if($new_options['tt_myspace_link_text'] ==
	__('Post to MySpace', 'tweet-this') &&
	tt_option('tt_myspace_link_text') ==
	__('Post to MySpace', 'tweet-this') &&
	$new_options['tt_myspace_icon'] != tt_option('tt_myspace_icon') &&
	($new_options['tt_myspace_icon'] == 'tt-myspace-big1.png' ||
	$new_options['tt_myspace_icon'] == 'tt-myspace-big2.png' ||
	$new_options['tt_myspace_icon'] == 'tt-myspace-big3.png' ||
	$new_options['tt_myspace_icon'] == 'tt-myspace-big4.png' ||
	$new_options['tt_myspace_icon'] == 'tt-myspace-micro3.png' ||
	$new_options['tt_myspace_icon'] == 'tt-myspace-micro4.png'))
		$new_options['tt_myspace_link_text'] = '[BLANK]';

	if($new_options['tt_ping_link_text'] ==
	__('Ping This Post', 'tweet-this') && tt_option('tt_ping_link_text') ==
	__('Ping This Post', 'tweet-this') &&
	$new_options['tt_ping_icon'] != tt_option('tt_ping_icon') &&
	($new_options['tt_ping_icon'] == 'tt-ping-big1.png' ||
	$new_options['tt_ping_icon'] == 'tt-ping-big2.png' ||
	$new_options['tt_ping_icon'] == 'tt-ping-big3.png' ||
	$new_options['tt_ping_icon'] == 'tt-ping-big4.png' ||
	$new_options['tt_ping_icon'] == 'tt-ping-micro3.png' ||
	$new_options['tt_ping_icon'] == 'tt-ping-micro4.png'))
		$new_options['tt_ping_link_text'] = '[BLANK]';

	if($new_options['tt_reddit_link_text'] ==
	__('Post to Reddit', 'tweet-this') &&
	tt_option('tt_reddit_link_text') ==
	__('Post to Reddit', 'tweet-this') &&
	$new_options['tt_reddit_icon'] != tt_option('tt_reddit_icon') &&
	($new_options['tt_reddit_icon'] == 'tt-reddit-big1.png' ||
	$new_options['tt_reddit_icon'] == 'tt-reddit-big2.png' ||
	$new_options['tt_reddit_icon'] == 'tt-reddit-big3.png' ||
	$new_options['tt_reddit_icon'] == 'tt-reddit-big4.png' ||
	$new_options['tt_reddit_icon'] == 'tt-reddit-micro3.png' ||
	$new_options['tt_reddit_icon'] == 'tt-reddit-micro4.png'))
		$new_options['tt_reddit_link_text'] = '[BLANK]';

	if($new_options['tt_su_link_text'] ==
	__('Stumble This Post', 'tweet-this') &&
	tt_option('tt_su_link_text') ==
	__('Stumble This Post', 'tweet-this') &&
	$new_options['tt_su_icon'] != tt_option('tt_su_icon') &&
	($new_options['tt_su_icon'] == 'tt-su-big1.png' ||
	$new_options['tt_su_icon'] == 'tt-su-big2.png' ||
	$new_options['tt_su_icon'] == 'tt-su-big3.png' ||
	$new_options['tt_su_icon'] == 'tt-su-big4.png' ||
	$new_options['tt_su_icon'] == 'tt-su-micro3.png' ||
	$new_options['tt_su_icon'] == 'tt-su-micro4.png'))
		$new_options['tt_su_link_text'] = '[BLANK]';

	update_option('tweet_this_settings', $new_options);
	echo	'<br /><div id="message" class="updated fade"><p>' .
		__('Tweet This options saved.', 'tweet-this') . $flush .
		'</p></div>';
}


/**
 * Outputs the list of image options for each social networking service in the
 * options form under Settings > Tweet This. This is a mess.
 */
function tt_image_selection($s) {
	$l = WP_PLUGIN_URL . '/' . TT_DIR . '/icons/';
	$c = ' checked="checked"';
	$z = '.png" /></label> <input type="radio" name="tt[tt_';
	echo	'<p><input type="radio" name="tt[tt_' . $s . '_icon]" id="' .
		$s . '-01" value="tt-' . $s . '.png"';
	if(tt_option('tt_' . $s . '_icon') == 'tt-' . $s . '.png' ||
		tt_option('tt_' . $s . '_icon') == '')
			echo	$c;
	echo	' /> <label for="' . $s . '-01"><img src="' . $l . 'tt-' . $s .
		'.png" alt="tt-' . $s .	$z . $s . '_icon]" id="' . $s .
		'-02" value="tt-' . $s . '-big1.png"';
	if(tt_option('tt_' . $s . '_icon') == 'tt-' . $s . '-big1.png')
		echo	$c;
	echo	' /> <label for="' . $s . '-02"><img src="' . $l . 'tt-' . $s .
		'-big1.png" alt="tt-' . $s . '-big1' . $z . $s .
		'_icon]" id="' . $s . '-03" value="tt-' . $s . '-big2.png"';
	if(tt_option('tt_' . $s . '_icon') == 'tt-' . $s . '-big2.png')
		echo	$c;
	echo	' /> <label for="' . $s . '-03"><img src="' . $l . 'tt-' . $s .
		'-big2.png" alt="tt-' . $s . '-big2' . $z . $s .
		'_icon]" id="' . $s . '-04" value="tt-' . $s . '-big3.png"';
	if(tt_option('tt_' . $s . '_icon') == 'tt-' . $s . '-big3.png')
		echo	$c;
	echo	' /> <label for="' . $s . '-04"><img src="' . $l . 'tt-' . $s .
		'-big3.png" alt="tt-' . $s . '-big3' . $z . $s .
		'_icon]" id="' . $s . '-05" value="tt-' . $s . '-big4.png"';
	if(tt_option('tt_' . $s . '_icon') == 'tt-' . $s . '-big4.png')
		echo	$c;
	echo	' /> <label for="' . $s . '-05"><img src="' . $l . 'tt-' . $s .
		'-big4.png" alt="tt-' . $s . '-big4' . $z . $s .
		'_icon]" id="' . $s . '-06" value="tt-' . $s . '-micro3.png"';
	if(tt_option('tt_' . $s . '_icon') == 'tt-' . $s . '-micro3.png')
		echo	$c;
	echo	' /> <label for="' . $s . '-06"><img src="' . $l . 'tt-' . $s .
		'-micro3.png" alt="tt-' . $s . '-micro3' . $z . $s .
		'_icon]" id="' . $s . '-07" value="tt-' . $s . '-micro4.png"';
	if(tt_option('tt_' . $s . '_icon') == 'tt-' . $s . '-micro4.png')
		echo	$c;
	echo	' /> <label for="' . $s . '-07"><img src="' . $l . 'tt-' . $s .
		'-micro4.png" alt="tt-' . $s . '-micro4' . $z . $s .
		'_icon]" id="' . $s . '-08" ' . 'value="noicon"';
	if(tt_option('tt_' . $s . '_icon') == 'noicon')
		echo	$c;
	echo	' /> <label for="' . $s . '-08">' .
		__('No icon.', 'tweet-this') . '</label></p>';
	if($s == 'twitter') {
		echo	'<p><input type="radio" name="tt[tt_twitter_icon]" ' .
			'id="twitter-09" value="tt-twitter2.png"';
		if(tt_option('tt_twitter_icon') == 'tt-twitter2.png')
			echo	$c;
		echo	' /> <label for="twitter-09"><img src="' . $l .
			'tt-twitter2.png" alt="tt-twitter2' . $z .
			'twitter_icon]" id="twitter-10" ' .
			'value="de/tt-twitter-big1-de.png"';
		if(tt_option('tt_twitter_icon') == 'de/tt-twitter-big1-de.png')
			echo	$c;
		echo	' /> <label for="twitter-10"><img src="' . $l .
			'de/tt-twitter-big1-de.png" ' .
			'alt="de/tt-twitter-big1-de' . $z . 'twitter_icon]" ' .
			'id="twitter-11" value="de/tt-twitter-big2-de.png"';
		if(tt_option('tt_twitter_icon') == 'de/tt-twitter-big2-de.png')
			echo	$c;
		echo	' /> <label for="twitter-11"><img src="' . $l .
			'de/tt-twitter-big2-de.png" ' .
			'alt="de/tt-twitter-big2-de' . $z . 'twitter_icon]" ' .
			'id="twitter-12" value="de/tt-twitter-big3-de.png"';
		if(tt_option('tt_twitter_icon') == 'de/tt-twitter-big3-de.png')
			echo	$c;
		echo	' /> <label for="twitter-12"><img src="' . $l .
			'de/tt-twitter-big3-de.png" ' .
			'alt="de/tt-twitter-big3-de' . $z . 'twitter_icon]" ' .
			'id="twitter-13" value="de/tt-twitter-big4-de.png"';
		if(tt_option('tt_twitter_icon') == 'de/tt-twitter-big4-de.png')
			echo	$c;
		echo	' /> <label for="twitter-13"><img src="' . $l .
			'de/tt-twitter-big4-de.png" ' .
			'alt="de/tt-twitter-big4-de' . $z . 'twitter_icon]" ' .
			'id="twitter-14" value="de/tt-twitter-micro3-de.png"';
		if(tt_option('tt_twitter_icon') ==
				'de/tt-twitter-micro3-de.png')
			echo	$c;
		echo	' /> <label for="twitter-14"><img src="' . $l .
			'de/tt-twitter-micro3-de.png" ' .
			'alt="de/tt-twitter-micro3-de' . $z .
			'twitter_icon]" id="twitter-15" ' .
			'value="de/tt-twitter-micro4-de.png"';
		if(tt_option('tt_twitter_icon') ==
				'de/tt-twitter-micro4-de.png')
			echo	$c;
		echo	' /> <label for="twitter-15"><img src="' . $l .
			'de/tt-twitter-micro4-de.png" ' .
			'alt="de/tt-twitter-micro4-de.png" /></label></p>';
		echo	'<p><input type="radio" name="tt[tt_twitter_icon]" ' .
			'id="twitter-16" value="tt-twitter3.png"';
		if(tt_option('tt_twitter_icon') == 'tt-twitter3.png')
			echo	$c;
		echo	' /> <label for="twitter-16"><img src="' . $l .
			'tt-twitter3.png" alt="tt-twitter3' . $z .
			'twitter_icon]" id="twitter-17" ' .
			'value="tt-twitter4.png"';
		if(tt_option('tt_twitter_icon') == 'tt-twitter4.png')
			echo	$c;
		echo	' /> <label for="twitter-17"><img src="' . $l .
			'tt-twitter4.png" alt="tt-twitter4' . $z .
			'twitter_icon]" id="twitter-21" ' .
			'value="tt-twitter5.png"';
		if(tt_option('tt_twitter_icon') == 'tt-twitter5.png')
			echo	$c;
		echo	' /> <label for="twitter-21"><img src="' . $l .
			'tt-twitter5.png" alt="tt-twitter5' . $z .
			'twitter_icon]" id="twitter-22" ' .
			'value="tt-twitter6.png"';
		if(tt_option('tt_twitter_icon') == 'tt-twitter6.png')
			echo	$c;
		echo	' /> <label for="twitter-22"><img src="' . $l .
			'tt-twitter6.png" alt="tt-twitter6' . $z .
			'twitter_icon]" id="twitter-18" ' .
			'value="tt-twitter-micro1.png"';
		if(tt_option('tt_twitter_icon') == 'tt-twitter-micro1.png')
			echo	$c;
		echo	' /> <label for="twitter-18"><img src="' . $l .
			'tt-twitter-micro1.png" alt="tt-twitter-micro1' . $z .
			'twitter_icon]" id="twitter-19" ' .
			'value="tt-twitter-micro2.png"';
		if(tt_option('tt_twitter_icon') == 'tt-twitter-micro2.png')
			echo	$c;
		echo	' /> <label for="twitter-19"><img src="' . $l .
			'tt-twitter-micro2.png" alt="tt-twitter-micro2' . $z .
			'twitter_icon]" id="twitter-20" value="textbox"';
		if(tt_option('tt_twitter_icon') == 'textbox')
			echo	$c;
		echo	' /> <label for="twitter-20">' .
			__('Editable text box', 'tweet-this') .	'</label> ' .
			'<label class="in">[' . __('Size', 'tweet-this') .
			': <input type="text" name="tt[tt_textbox_size]" ' .
			'id="tt[tt_textbox_size]" size="2" value="';
		if(tt_option('tt_textbox_size') == '')
			echo	'60';
		else echo	tt_option('tt_textbox_size');
		echo	'" />]</label></p>';
		}
}


/**
 * Outputs the select option for each URL service when fed the correct
 * arguments. Used for the options form under Settings > Tweet This.
 */
function tt_url_service($id = 'local', $title = 'Local', $special = '') {
	if($id == 'snurl') $id = 'snipurl';
	if(strtolower($title) == 'snurl.com') $title = 'SnipURL.com';
	if($special == 'admin' || $special == 'admindefault')
		$service = tt_option('tt_admin_url_service');
	else $service = tt_option('tt_url_service');
	echo	'<option value="' . $id . '"';
	if(str_replace('snurl', 'snipurl', $service) == $id
		|| (($special == 'default' || $special == 'admindefault') &&
		$service == '')) echo ' selected="selected"';
	echo	'>' . $title . ' ';
	if($id == 'local') {
		$local = str_replace('https://', 'http://',
			get_bloginfo('url')) . '/?p=1234';
		if(tt_option('tt_url_www') == 'true')
			$local = str_replace('http://', 'www.',
				str_replace('http://www.', 'www.', $local));
		echo	$local . ' ';
	}
	printf(__('(%1$s Characters)', 'tweet-this'),
		get_tt_url_service_len($id));
	if($id == 'local') echo ' &nbsp;';
	echo	'</option>';
}


/**
 * Gets the length of the URLs of the current URL shortening service.
 */
function get_tt_url_service_len($service = '') {
	if($service == 'snurl') $service = 'snipurl';
	if($service == '' || $service == 'same')
		$service = tt_option('tt_url_service');
	if($service == '' || $service == 'same') $service = 'local';
	$len = constant('TT_' . strtoupper(str_replace('.', '',
		$service)) . '_LEN');
	if(tt_option('tt_url_www') == 'true' && $service != 'tweetburner')
		$len -= 3;
	if($service == 'adjix' && tt_option('tt_ad_vu') != 'false')
		$len -= 4;
	elseif($service == 'bit.ly' && tt_option('tt_j_mp') == 'true')
		$len -= 2;
	elseif($service == 'snipurl' && (tt_option('tt_snipurl_domain') ==
		'snipr.com' || tt_option('tt_snipurl_domain') == 'snurl.com'))
		$len -= 2;
	elseif($service == 'snipurl' && (tt_option('tt_snipurl_domain') ==
		'sn.im' || tt_option('tt_snipurl_domain') == 'cl.lk'))
		$len -= 6;
	return $len;
}


/**
 * Echoes the above function for convenience.
 */
function tt_url_service_len($service = '') {
	echo get_tt_url_service_len($service, $special);
}


/**
 * Connects to Twitter using OAuth.
 * Based in part on: http://wordpress.org/extend/plugins/twitter-tools/
 * Twitter Tools  Copyright 2008 - 2010  Alex King  http://alexking.org/
 */
function tt_oauth_connection($key = '', $secret = '', $token = '',
	$token_sec = '') {
	if($key == '') $key = tt_option('tt_app_consumer_key');
	if($secret == '') $secret = tt_option('tt_app_consumer_secret');
	if($token == '') $token = tt_option('tt_oauth_token');
	if($token_sec == '') $token_sec = tt_option('tt_oauth_token_secret');
	$key = trim($key);
	$secret = trim($secret);
	$token = trim($token);
	$token_sec = trim($token_sec);
	if($key != '' && $secret != '' && $token != '' && $token_sec != '') {
		if(!class_exists('TwitterOAuth')) {
			require_once(TT_OAUTH);
			$connection = new TwitterOAuth($key, $secret, $token,
				$token_sec);}
		else {	require_once(TT_OAUTH_SPECIAL);
			$connection = new TweetThisTwitterOAuth($key, $secret,
				$token, $token_sec);}
		$connection->useragent = 'Tweet This ' .
			'http://richardxthripp.thripp.com/tweet-this/';
		return $connection;
	}
	else return false;
}


/**
 * Used in the options form to test the Twitter OAuth keys.
 * Based in part on: http://wordpress.org/extend/plugins/twitter-tools/
 * Twitter Tools  Copyright 2008 - 2010  Alex King  http://alexking.org/
 */
function tt_oauth_test($key = '', $secret = '', $token = '', $token_sec = '') {
	if($key != '' && $secret != '' && $token != '' && $token_sec != '') {
		$connection =	tt_oauth_connection($key, $secret, $token,
				$token_sec);
		$data = 	$connection->get('account/verify_credentials');
		if($connection->http_code == '200') {
			$data = json_decode($data);
			return	' <strong><font color="green">' .
				__('Authentication succeeded, please save.',
				'tweet-this') . '</font></strong>';
		}
		else return	' <strong><font color="red">' .
				__('Authentication failed, make sure your ' .
				'keys are entered correctly.', 'tweet-this') .
				'</font></strong>';
	}
	else return	' <strong><font color="red"> ' . __('Authentication ' .
			'failed, please copy and paste all four keys.',
			'tweet-this') . '</font></strong>';
}


/**
 * Delimits URLs by adding a space on each side.
 * Based on: http://github.com/jmrware/LinkifyURL
 * LinkifyURL  Copyright 2010  Jeff Roberson  http://jmrware.com/
 * MIT License: http://www.opensource.org/licenses/mit-license.php
 */
function tt_delimit_urls($text, $delimiter = ' ') {
    $url_pattern = '/# Match http & ftp URL that is not already linkified.
      # Alternative 1: URL delimited by (parentheses).
      (\()                     # $1  "(" start delimiter.
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $2: URL.
      (\))                     # $3: ")" end delimiter.
    | # Alternative 2: URL delimited by [square brackets].
      (\[)                     # $4: "[" start delimiter.
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $5: URL.
      (\])                     # $6: "]" end delimiter.
    | # Alternative 3: URL delimited by {curly braces}.
      (\{)                     # $7: "{" start delimiter.
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $8: URL.
      (\})                     # $9: "}" end delimiter.
    | # Alternative 4: URL delimited by <angle brackets>.
      (<|&(?:lt|\#60|\#x3c);)  # $10: "<" start delimiter (or HTML entity).
      ((?:ht|f)tps?:\/\/[a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]+)  # $11: URL.
      (>|&(?:gt|\#62|\#x3e);)  # $12: ">" end delimiter (or HTML entity).
    | # Alternative 5: URL not delimited by (), [], {} or <>.
      (                        # $13: Prefix proving URL not already linked.
        (?: ^                  # Can be a beginning of line or string, or
        | [^=\s\'"\]]          # a non-"=", non-quote, non-"]", followed by
        ) \s*[\'"]?            # optional whitespace and optional quote;
      | [^=\s]\s+              # or a non-equals sign followed by whitespace.
      )                        # End $13. Non-prelinkified-proof prefix.
      ( \b                     # $14: Other non-delimited URL.
        (?:ht|f)tps?:\/\/      # Required http, https, ftp or ftps prefix.
        [a-z0-9\-._~!$\'()*+,;=:\/?#[\]@%]+ # All URI chars except "&".
        (?:                    # Either on a "&" or at the end of URI.
          (?!                  # Allow a "&" char only if not start of an...
            &(?:gt|\#0*62|\#x0*3e);                  # HTML ">" entity, or
          | &(?:amp|apos|quot|\#0*3[49]|\#x0*2[27]); # a [&\'"] entity if
            [.!&\',:?;]?        # followed by optional punctuation then
            (?:[^a-z0-9\-._~!$&\'()*+,;=:\/?#[\]@%]|$) # a non-URI char or EOS.
          ) &                  # If neg-assertion true, match "&" (special).
          [a-z0-9\-._~!$\'()*+,;=:\/?#[\]@%]* # More non-& URI chars.
        )*                     # Unroll-the-loop (special normal*)*.
        [a-z0-9\-_~$()*+=\/#[\]@%]  # Last char can\'t be [.!&\',;:?]
      )                        # End $14. Other non-delimited URL.
    /imx';
    $url_replace =	'$1$4$7$10$13' . $delimiter . '$2$5$8$11$14' .
			$delimiter . '$3$6$9$12';
    return	trim(str_replace('  ', ' ',
		preg_replace($url_pattern, $url_replace, $text)));
}


/**
 * Shortens URLs in new tweets through Bit.ly.
 * Based on: http://www.phpclasses.org/browse/package/6114.html
 * Ext-Conv-Links  Copyright 2010  Muhammad Arfeen  http://arfeen.net/
 */
class tt_shorten_urls {
	function tt_shorten_urls($bitlyLogin, $bitlyAPIKey) {
		$this->_bitlyLogin = $bitlyLogin;
		$this->_bitlyAPIKey = $bitlyAPIKey;}
	function ExtractAndConvert($text = '') {
		$text = trim(str_replace('  ', ' ',
			tt_delimit_urls($text, ' ')));
		$hyperlinksArray = array();
		preg_match_all('(((f|ht){1}(tp://|tps://))' .
			'[-a-zA-Z0-9@:%_+.~#?&//=]+)', $text,
			$hyperlinksArray);
		for($i = 0; $i < count($hyperlinksArray[0]); $i++) {
			$ShortLink = $this->_GetSortenLinkViaAPI(
				$hyperlinksArray[0][$i]);
			if(tt_option('tt_j_mp') == 'true')
				$ShortLink = str_replace('http://bit.ly/',
				'http://j.mp/', $ShortLink);
			$text = str_replace($hyperlinksArray[0][$i],
				$ShortLink, $text);} return $text;}
	function _GetSortenLinkViaAPI($URL) {
		$service = tt_option('tt_admin_url_service');
		if($service == 'same') $service = tt_option('tt_url_service');
		if($service == '' || $service == 'same' || $service == 'local')
			$service = 'bit.ly';
		if($this->_bitlyLogin != '' && $this->_bitlyAPIKey != '' &&
		$service == 'bit.ly')
			$BitlyXML = tt_read_file('http://api.bit.ly/shorten?' .
			'version=2.0.1&longUrl=' . urlencode($URL) .
			'&login=' . $this->_bitlyLogin . '&apiKey=' .
			$this->_bitlyAPIKey . '&format=xml');
		else {	$geturl = get_tweet_this_short_url($URL, '', true,
				true, '');
			$BitlyXML = '<bitly><errorCode>0</errorCode>' .
			'<errorMessage></errorMessage><results><nodeKeyVal>' .
			'<shortKeywordUrl></shortKeywordUrl><hash>null' .
			'</hash><userHash>null</userHash><nodeKey><![CDATA[' .
			'http://www.google.com/]]></nodeKey><shortUrl>' .
			$geturl . '</shortUrl><shortCNAMEUrl>' . $geturl .
			'</shortCNAMEUrl></nodeKeyVal></results><statusCode>' .
			'OK</statusCode></bitly>';}
		$XMLtoArray = $this->_ConvXMLtoArray($BitlyXML);
		if(isset($XMLtoArray['bitly']['results']['nodeKeyVal']
			['shortUrl']['_value_'])) return $XMLtoArray['bitly']
			['results']['nodeKeyVal']['shortUrl']['_value_'];}
	function _ConvXMLtoArray($contents, $get_attributes = 1) {
		if(!$contents || !function_exists('xml_parser_create'))
			return array();
		$parser = xml_parser_create();
		xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
		xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
		xml_parse_into_struct($parser, $contents, $xml_values);
		xml_parser_free($parser); if(!$xml_values) return;
		$xml_array = array(); $parents = array();
		$opened_tags = array(); $arr = array(); $current = &$xml_array;
		foreach($xml_values as $data) {unset($attributes, $value);
			extract($data); $result = ''; if($get_attributes) {
				$result = array();
				if(isset($value)) $result['_value_'] = $value;
				if(isset($attributes)) {
					foreach($attributes as $attr => $val)
					if($get_attributes == 1)
					$result['_attr_'][$attr] = $val;}}
			elseif(isset($value)) $result = $value;
			if($type == 'open') {
				$parent[$level - 1] = &$current;
				if(!is_array($current) || (!in_array($tag,
				array_keys($current)))) {
					$current[$tag] = $result;
					$current = &$current[$tag];} else {
					if(isset($current[$tag][0]))
					   array_push($current[$tag], $result);
					else $current[$tag] =
					   array($current[$tag], $result);
					$last = count($current[$tag]) - 1;
					$current = &$current[$tag][$last];}}
			elseif($type == 'complete') {if(!isset($current[$tag]))
				$current[$tag] = $result; else {
				if((is_array($current[$tag]) && $get_attributes
				== 0) || (isset($current[$tag][0]) &&
				is_array($current[$tag][0]) && $get_attributes
				== 1)) array_push($current[$tag], $result);
				else $current[$tag] =
					array($current[$tag], $result);}}
		elseif($type == 'close') $current = &$parent[$level - 1];} 
	return($xml_array);}
}


/**
 * Handles key verification, forwarding, and new tweets.
 * Based in part on: http://wordpress.org/extend/plugins/twitter-tools/
 * Twitter Tools  Copyright 2008 - 2010  Alex King  http://alexking.org/
 */
function tt_request_handler() {
	if(isset($_REQUEST['ttaction'])) switch($_REQUEST['ttaction']) {
	case 'tt_oauth_test':
		$test = @tt_oauth_test($_POST['tt_app_consumer_key'],
			$_POST['tt_app_consumer_secret'],
			$_POST['tt_oauth_token'],
			$_POST['tt_oauth_token_secret']);
		die(__($test, 'tweet-this'));
	break;
	case 'tt_twitter_box':
		$link =	'http://twitter.com/home/?status=' . urlencode(
			@html_entity_decode(stripslashes(
			$_REQUEST['tt_twitter_box_text']), ENT_COMPAT,
			'UTF-8'));
		die('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 ' .
		'Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/' .
		'xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/' .
		'1999/xhtml" xml:lang="en" lang="en"><head><title>' .
		__('Sending you to Twitter...', 'tweet-this') . '</title>' .
		'<meta http-equiv="content-type" content="text/html; ' .
		'charset=utf-8" /><meta http-equiv="refresh" content="0;url=' .
		$link . '" /></head><body><p>' . __('Sending you to Twitter' .
		'...', 'tweet-this') . '<a href="' . $link . '">' .
		__('Click here if nothing happens.', 'tweet-this') .
		'</a></p></body></html>');
	break;
	case 'tt_write_tweet':
		if($_POST['tt_app_consumer_secret'] !=
		tt_option('tt_app_consumer_secret') &&
		trim(tt_option('tt_app_consumer_secret')) != '')
			die('&nbsp;&nbsp;<strong><font color="red">' .
			__('Cannot authenticate you as WordPress admin.',
			'tweet-this') . '</font></strong>');
		elseif(trim($_POST['tt_tweet_text']) == '')
			die('&nbsp;&nbsp;<strong><font color="red">' .
			__('Cannot publish a blank tweet.', 'tweet-this') .
			'</font></strong>');
		elseif(tt_option('tt_app_consumer_key') != '' &&
		tt_option('tt_app_consumer_secret') != '' &&
		tt_option('tt_oauth_token') != '' &&
		tt_option('tt_oauth_token_secret') != '') {
			$ECLObj = new tt_shorten_urls(
				tt_option('tt_bitly_username'),
				tt_option('tt_bitly_api_key'));
			$status = stripslashes(trim(str_replace(array("/^\s+/",
				"/\s{2,}/", "/\s+\$/"), array('', ' ', ''),
				$_POST['tt_tweet_text'])));
			if(strlen($status) > 140)
				$status = $ECLObj->ExtractAndConvert($status);
			$connection = tt_oauth_connection();
			$connection->decode_json = true;
			$data = $connection->post(TT_API_POST_STATUS,
				array('status' => $status, 'source' =>
				'tweetthis'));
			if($connection->http_code == '200')
				die('&nbsp;&nbsp;<strong><font color=' .
				'"green">' . __('Tweet published to Twitter ' .
				'successfully.', 'tweet-this') . ' (<a href=' .
				'"http://twitter.com/' . $data->user->screen_name .
				'/status/' . $data->id . '" target="_blank">' .
				$data->id . '</a>)</font></strong>');
			else die(printf('&nbsp;&nbsp;<strong><font color=' .
			'"red">' . __('Tweet failed: Twitter returned HTTP ' .
			'%1$s.', 'tweet-this') . '</font></strong>',
			$connection->http_code));}
	else	die('&nbsp;&nbsp;<strong><font color="red">' .
		__('Tweet failed: OAuth key(s) missing.', 'tweet-this') .
		'</font></strong>');
	break;
	case 'tt_shorten_urls':
		$ECLObj = new tt_shorten_urls(tt_option('tt_bitly_username'),
			tt_option('tt_bitly_api_key'));
		$status = stripslashes(trim(str_replace(array("/^\s+/",
			"/\s{2,}/", "/\s+\$/"), array('', ' ', ''),
			$_POST['tt_tweet_text'])));
		if($_POST['tt_app_consumer_secret'] !=
		tt_option('tt_app_consumer_secret') &&
		trim(tt_option('tt_app_consumer_secret')) != '')
			die('&nbsp;&nbsp;<strong><font color="red">' .
			__('Cannot authenticate you as a WordPress admin.',
			'tweet-this') . '</font></strong>');
		elseif($status == '')
			die('&nbsp;&nbsp;<strong><font color="red">' .
			__('No tweet text to preview.', 'tweet-this') .
			'</font></strong>');
		else {	if(strlen($status) > 140) {
			$status = $ECLObj->ExtractAndConvert($status);
				$lenmsg = '.'; $lenbr = '';}
			else {	$lenmsg = __(', or more if your tweet ' .
				'contains URLs.', 'tweet-this');
				$lenbr = '<br />';}
			if(strlen($status) < 141) {
				$count = '<strong><font color="green">' .
				strlen($status) . '</font></strong>';
				$remaining = '<strong><font color="green">' .
				(140 - strlen($status)) . '</font></strong>';
				$message = $lenbr . __('You can add ',
				'tweet-this') . $remaining .
				__(' character(s)', 'tweet-this') . $lenmsg;}
				else {$count = '<strong><font color="red">' .
				strlen($status) . '</font></strong>';
				$remaining = '<strong>' . (strlen($status) -
				140) . '</strong>';
				$message = '<font color="red">' .
				__('You must remove ', 'tweet-this') .
				$remaining . __(' character(s).',
				'tweet-this') . '</font>';}
		die('<div id="tt_tweet_preview_details" style="border:2px ' .
		'solid #4a4a4a;background-color:#f5f5f5;padding:0 10px 0 ' .
		'10px;margin:10px 0 10px 6px;width:750px;"><p>' .
		__('Your final tweet will contain ', 'tweet-this') . $count .
		__(' character(s).', 'tweet-this') . ' ' . $message .
		'</p></div><div id="tt_tweet_preview" style="border:2px ' .
		'solid #007f00;background-color:#e8ffe8;padding:0 10px 0 ' .
		'10px;margin-left:6px;width:750px;"><p>' .
		htmlentities($status) . '</p></div>');}
	break;
	case 'tt_schedule_tweet':
		$ECLObj = new tt_shorten_urls(tt_option('tt_bitly_username'),
			tt_option('tt_bitly_api_key'));
		$status = stripslashes(trim(str_replace(array("/^\s+/",
			"/\s{2,}/", "/\s+\$/"), array('', ' ', ''),
			$_POST['tt_tweet_text'])));
		$getdate = trim($_POST['tt_schedule_date']);
		if(strlen($getdate) == 10) $getdate .= ' 00:00:00';
		$date = strftime("%F %T", strtotime($getdate));
		if(strlen($status) > 140)
			$status = $ECLObj->ExtractAndConvert($status);
		if($_POST['tt_app_consumer_secret'] !=
		tt_option('tt_app_consumer_secret') &&
		trim(tt_option('tt_app_consumer_secret')) != '')
			die('&nbsp;&nbsp;<strong><font color="red">' .
			__('Cannot authenticate you as a WordPress admin.',
			'tweet-this') . '</font></strong>');
		elseif($status == '')
			die('&nbsp;&nbsp;<strong><font color="red">' .
			__('No tweet text to schedule.', 'tweet-this') .
			'</font></strong>');
		elseif(strlen($status) > 140)
			die('&nbsp;&nbsp;<strong><font color="red">' .
			__('Tweet not scheduled because it is <strong>',
			'tweet-this') . strlen($status) . __('</strong> ' .
			'characters.', 'tweet-this') . '</font></strong>');
		elseif(time() > strtotime($getdate))
			die('&nbsp;&nbsp;<strong><font color="red">' .
			__('Tweet not scheduled because provided date is ' .
			'invalid or in the past.', 'tweet-this') .
			'</font></strong>');
		else {	global $wpdb;
			if(!get_option('tweet_this_db_version')) {
				tt_install_tables(); $table = 'true';}
			if($table == 'true') $table_text = __('Created ' .
				'database table `<strong>', 'tweet-this') .
				$wpdb->prefix . 'tweet_this_scheduled' .
				__('</strong>` successfully.', 'tweet-this') .
				'</font></p><p><font color="green">';
			global $current_user;
			get_currentuserinfo();
			$dupe = $wpdb->get_row("SELECT ID, tt_modified FROM
				$wpdb->rxtt WHERE tt_date = '$date'");
			if($dupe->ID != '') {
				die('<div id="tt_schedule_details" style=' .
				'"border:2px solid #7f0000;background-color:' .
				'#ffe8e8;padding:0 10px 0 10px;margin:10px ' .
				'0 10px 6px;width:750px;"><p><font color=' .
				'"red">' . __('Tweet <strong>#',
				'tweet-this') . $dupe->ID . __('</strong>, ' .
				'added <strong>', 'tweet-this') .
				$dupe->tt_modified . __('</strong>, is also ' .
				'scheduled for <strong>', 'tweet-this') .
				$date . __('</strong>. Please change dates.',
				'tweet-this') . '</font></p></div>');} else {
				$wpdb->insert($wpdb->rxtt, array('tt_author' =>
				$current_user->ID, 'tt_date' => $date,
				'tt_content' => $status, 'tt_status' =>
				'future', 'tt_modified' => date("Y-m-d H:i:s"),
				'tt_response' => '0'));
				die('<div id="tt_schedule_details" style=' .
				'"border:2px solid #005e00;background-color:' .
				'#f4fff4;padding:0 10px 0 10px;margin:10px ' .
				'0 10px 6px;width:750px;"><p><font color=' .
				'"green">' . $table_text . __('Tweet ' .
				'scheduled for <strong>', 'tweet-this') .
				$date . __('</strong> successfully. <a href="',
				'tweet-this') . get_bloginfo('url') . '/wp-' .
				'admin/edit.php' . constant('TT_FILE_LOC') .
				'">' . __('Click here</a> to refresh.',
				'tweet-this') . '</font></p></div>');}}
	break;}
}


/**
 * Displays the options form under Settings > Tweet This.
 */
function print_tt_form() {
	if(file_exists(TT_OPTIONS)) {
		if(function_exists('wp_enqueue_script'))
			wp_enqueue_script('jquery');
		require(TT_OPTIONS);
	}
	else echo	'<p>' . __('The file that constructs the options ' .
			'form, /tweet-this/lib/tt-options.php, is missing.',
			'tweet-this') . '</p>';
}


/**
 * Adds the default Tweet This options to the database upon activation of the
 * plugin or resetting of the options. Cleans up some old records from
 * Tweet This v1.1 if they are still present.
 */
function tweet_this_install() {
	$add_options = array('tt_30' => 'false', 'tt_url_service' => 'local',
		'tt_admin_url_service' => 'bit.ly', 'tt_alignment' => 'left',
		'tt_limit_to_single' => 'false', 'tt_limit_to_posts' =>
		'false', 'tt_url_www' => 'false', 'tt_footer' => 'false',
		'tt_ads' => 'false', 'tt_new_window' => 'false',
		'tt_nofollow' => 'false', 'tt_img_css_class' => 'nothumb',
		'tt_link_css_class' => 'tt', 'tt_css' =>
		'img.[IMG_CLASS]{border:0;}', 'tt_shortlink_filter' => 'true',
		'tt_adjix_api_key' => '', 'tt_ad_vu' => 'true', 'tt_j_mp' =>
		'false', 'tt_bitly_username' => '', 'tt_bitly_api_key' => '',
		'tt_snipurl_username' => '', 'tt_snipurl_api_key' => '',
		'tt_supr_username' => '', 'tt_supr_api_key' => '',
		'tt_snipurl_domain' => 'snipurl.com','tt_custom_url_service' =>
		'http://tinyurl.com/api-create.php?url=[LONGURL]',
		'tt_auto_tweet_display' => 'true',
		'tt_auto_tweet_display_pages' => 'true',
		'tt_auto_tweet' => 'false', 'tt_auto_tweet_pages' => 'false',
		'tt_auto_tweet_text' =>	__('New blog post', 'tweet-this') .
		': [TITLE] [URL]', 'tt_app_consumer_key' => '',
		'tt_app_consumer_secret' => '',	'tt_oauth_token' => '',
		'tt_oauth_token_secret' => '', 'tt_textbox_size' => '60',
		'tt_auto_display' => 'true', 'tt_tweet_text' =>
			'[TITLE] [URL]', 'tt_link_text' =>
			__('Tweet This Post', 'tweet-this'), 'tt_title_text' =>
			__('Post to Twitter', 'tweet-this'),
			'tt_twitter_icon' => 'tt-twitter.png',
		'tt_twitter_share' => 'false', 'tt_twitter_share_text' =>
			'[TITLE_SHARE]', 'tt_twitter_share_via' =>
			'tweetthisplugin', 'tt_twitter_share_rel' =>
			'richardxthripp,tweetthisplugin',
		'tt_plurk' => 'false', 'tt_plurk_text' => '[TITLE] [URL]',
			'tt_plurk_link_text' => __('Plurk This Post',
			'tweet-this'), 'tt_plurk_title_text' =>
			__('Post to Plurk', 'tweet-this'), 'tt_plurk_icon' =>
			'tt-plurk.png',
		'tt_buzz' => 'false', 'tt_buzz_link_text' =>
			__('Buzz This Post', 'tweet-this'),
			'tt_buzz_title_text' => __('Post to Yahoo Buzz',
			'tweet-this'), 'tt_buzz_icon' => 'tt-buzz.png',
		'tt_delicious' => 'false', 'tt_delicious_link_text' =>
			__('Post to Delicious', 'tweet-this'),
			'tt_delicious_title_text' => __('Post to Delicious',
			'tweet-this'), 'tt_delicious_icon' =>
			'tt-delicious.png',
		'tt_digg' => 'false', 'tt_digg_link_text' =>
			__('Digg This Post', 'tweet-this'),
			'tt_digg_title_text' => __('Post to Digg',
			'tweet-this'), 'tt_digg_icon' => 'tt-digg.png',
		'tt_facebook' => 'false', 'tt_facebook_link_text' =>
			__('Post to Facebook', 'tweet-this'),
			'tt_facebook_title_text' => __('Post to Facebook',
			'tweet-this'), 'tt_facebook_icon' => 'tt-facebook.png',
		'tt_myspace' => 'false', 'tt_myspace_link_text' =>
			__('Post to MySpace', 'tweet-this'),
			'tt_myspace_title_text' =>
			__('Post to MySpace', 'tweet-this'),
			'tt_myspace_icon' => 'tt-myspace.png',
		'tt_ping' => 'false', 'tt_ping_link_text' =>
			__('Ping This Post', 'tweet-this'),
			'tt_ping_title_text' => __('Post to Ping.fm',
			'tweet-this'), 'tt_ping_icon' => 'tt-ping.png',
		'tt_reddit' => 'false', 'tt_reddit_link_text' =>
			__('Post to Reddit', 'tweet-this'),
			'tt_reddit_title_text' => __('Post to Reddit',
			'tweet-this'), 'tt_reddit_icon' => 'tt-reddit.png',
		'tt_su' => 'false', 'tt_su_link_text' =>
			__('Stumble This Post', 'tweet-this'),
			'tt_su_title_text' => __('Post to StumbleUpon',
			'tweet-this'), 'tt_su_icon' => 'tt-su.png');
	foreach($add_options as $key => $value) {
		if($old = get_option($key)) {
			$add_options[$key] = $old; delete_option($key);}}
	if(!get_option('tweet_this_settings'))
		add_option('tweet_this_settings', $add_options);
	elseif(strlen(serialize(get_option('tweet_this_settings'))) < 100)
		update_option('tweet_this_settings', $add_options);
	delete_option('tweet_this_password');
	delete_option('tt_add_title');
	delete_option('tt_big_icon');
	delete_option('tt_icon');
	delete_option('tt_small_icon');
	delete_option('tweet_this_import_key');
}


/**
 * Installs the MySQL table for scheduled tweets.
 */
function tt_install_tables() {
	global $wpdb; $cc = '';
	if(version_compare(mysql_get_server_info(), '4.1.0', '>=')) {
		if(!empty($wpdb->charset))
			$cc .= " DEFAULT CHARACTER SET $wpdb->charset";
		if(!empty($wpdb->collate)) $cc .= " COLLATE $wpdb->collate";}
	$result = $wpdb->query("
		CREATE TABLE IF NOT EXISTS `$wpdb->rxtt` (
		`ID` bigint(20) unsigned NOT NULL auto_increment,
		`tt_author` bigint(20) unsigned NOT NULL default '0',
		`tt_date` datetime NOT NULL default '0000-00-00 00:00:00',
		`tt_content` longtext NOT NULL,
		`tt_status` varchar(20) NOT NULL default 'future',
		`tt_modified` datetime NOT NULL default '0000-00-00 00:00:00',
		`tt_response` varchar(20) NOT NULL default '0',
		PRIMARY KEY  (`ID`)
		) $cc
	");
	update_option('tweet_this_db_version', TT_DB_VERSION);
	update_option('tweet_this_last_cron', (time() - 86400));
}


/**
 * Inserts the Options, Write Tweet, and Scheduled Tweets pages.
 */
function tweet_this_add_options() {
	// WP 1.5 compatibility.
	if(version_compare($GLOBALS['wp_version'], '2.0', '<')) {
		$filename = __FILE__; $postfile = 'post.php';
		get_currentuserinfo(); global $user_level;
		if($user_level >= 5) {
			$manage = true; $publish = true;}}
	else {	$filename = basename(__FILE__); $postfile = 'post-new.php';
		if(current_user_can('manage_options')) $manage = true;
		if(current_user_can('publish_posts')) $publish = true;}
	if($manage == true && function_exists('add_options_page'))
		add_options_page(__('Tweet This Options', 'tweet-this'),
			__('Tweet This', 'tweet-this'), 8,
			$filename, 'tweet_this_options');
	if($publish == true && function_exists('add_submenu_page') &&
	tt_option('tt_app_consumer_key') != '' &&
	tt_option('tt_app_consumer_secret') != '' &&
	tt_option('tt_oauth_token') != '' &&
	tt_option('tt_oauth_token_secret') != '')
		add_submenu_page($postfile, __('Write Tweet',
			'tweet-this'), __('Write Tweet', 'tweet-this'), 2,
			$filename, 'tt_admin_tweet_form');
}


/**
 * Prints the New Tweet page.
 */
function tt_admin_tweet_form() {
	if(function_exists('wp_enqueue_script')) wp_enqueue_script('jquery');
	echo	'<script type="text/javascript">function ttWriteTweet() {var' .
		' result = jQuery(\'#tt_write_tweet_result\');result.show().' .
		'addClass(\'tt_write_tweet_wait\').html(\'&nbsp;&nbsp;' .
		'<strong>' . __('Sending...', 'tweet-this') . '</strong>\');' .
		'jQuery.post("' . get_bloginfo('wpurl') . '/index.php", ' .
		'{ttaction: \'tt_write_tweet\', tt_app_consumer_secret: \'' .
		tt_option('tt_app_consumer_secret') . '\', tt_tweet_text: ' .
		'jQuery(\'#tt_tweet_text\').val()}, function(data) {result.' .
		'html(data).removeClass(\'tt_write_tweet_wait\');});} ' .
		'function ttScheduleTweet() {var result = jQuery(\'#tt_' .
		'schedule_tweet_result\');result.show().addClass(\'tt_' .
		'schedule_tweet_wait\').html(\'&nbsp;&nbsp;<strong>' .
		__('Scheduling...', 'tweet-this') . '</strong>\');' .
		'jQuery.post("' . get_bloginfo('wpurl') . '/index.php", ' .
		'{ttaction: \'tt_schedule_tweet\', tt_app_consumer_secret:' .
		' \'' . tt_option('tt_app_consumer_secret') . '\', tt_tweet_' .
		'text: jQuery(\'#tt_tweet_text\').val(), tt_schedule_date: ' .
		'jQuery(\'#tt_date_text\').val()}, function(data) {result.' .
		'html(data).removeClass(\'tt_schedule_tweet_wait\');});}' .
		'function ttShortenURLs() {var result = ' .
		'jQuery(\'#tt_shorten_urls_result\');result.show().' .
		'addClass(\'tt_shorten_urls_wait\').html(\'&nbsp;&nbsp;' .
		'<strong>' . __('Generating preview...', 'tweet-this') .
		'</strong>\');jQuery.post("' . get_bloginfo('wpurl') .
		'/index.php", {ttaction: \'tt_shorten_urls\', tt_app_' .
		'consumer_secret: \'' .tt_option('tt_app_consumer_secret') .
		'\', tt_tweet_text: jQuery(\'#tt_tweet_text\').val()}, ' .
		'function(data) {result.html(data).removeClass(\'tt_shorten_' .
		'urls_wait\');});} function ttWriteTweetResult() {jQuery(\'' .
		'#tt_write_tweet_result\');} function ttScheduleTweetResult' .
		'() {jQuery(\'#tt_schedule_tweet_result\');} function ' .
		'ttShortenURLsResult() {jQuery(\'#tt_shorten_urls_result\');' .
		'} var lastDiv = \'\';</script><div class="wrap"><h2>';
	printf(__('<a target="_blank" href="http://richardxthripp.thripp.com' .
		'/tweet-this/">Tweet This</a> <a target="_blank" href=' .
		'"http://richardxthripp.thripp.com/tweet-this-version-' .
		'history/">v%1$s</a>: Write Tweet', 'tweet-this'), TT_VERSION);
	echo	'</h2><p style="margin-bottom:0;">' . __('This will create ' .
		'a new tweet in <a target="_blank" href="http://twitter.com"' .
		'>Twitter</a> using your OAuth connection.', 'tweet-this') .
		'</p><form action="' . get_bloginfo('wpurl') . '/index.php" ' .
		'method="post" id="tt_tweet_form"><fieldset><p><textarea ' .
		'type="text" cols="104" rows="5" id="tt_tweet_text" name=' .
		'"tt_tweet_text" onchange="ttCharCount();" onclick=' .
		'"ttCharCount();" onkeyup="ttCharCount();"></textarea></p>' .
		'<script type="text/javascript">
		//<![CDATA[
		function ttCharCount() {
			var count = document.getElementById' .
				'("tt_tweet_text").value.length;
			document.getElementById("tt_char_count").innerHTML =' .
				' "<strong>" + (count) + "</strong>"' .
				' + "' . __(' character(s) before URL ' .
				'shortening.', 'tweet-this') . '";}
		setTimeout("ttCharCount();", 500);
		document.getElementById("tt_tweet_text").' .
			'setAttribute("autocomplete", "off");
		//]]></script></div><p style="margin-top:0;">' .
		'&nbsp;&nbsp;<input type="button" class="button" name=' .
		'"tt_write_tweet_final" id="tt_write_tweet_final" value="' .
		__('Tweet This', 'tweet-this') . '" title="' .
		__('Click to publish Twitter status update.', 'tweet-this') .
		'" onclick="ttWriteTweet(); return false;" /> <input type=' .
		'"button" class="button" name="tt_shorten_urls_final" id=' .
		'"tt_shorten_urls_final" value="' .
		__('Preview This', 'tweet-this') . '" title="' .
		__('Click here if your Tweet contains URLs.', 'tweet-this') .
		'" onclick="ttShortenURLs(); return false;" /> <input type=' .
		'"button" class="button" name="tt_schedule_tweet_final" id=' .
		'"tt_schedule_tweet_final" value="' . __('Schedule This',
		'tweet-this') . '" title="' . __('Click to schedule future ' .
		'Twitter status update.', 'tweet-this') . '" onclick=' .
		'"ttScheduleTweet(); return false;" /> Date: <input type=' .
		'"text" name="tt_date_text" id="tt_date_text" size="21" ' .
		'maxlength="19" autocomplete="off" value="' .
		date("Y-m-d H:i:s", time() + 3600) . '" />&nbsp;&nbsp;' .
		'<span id="tt_char_count"></span></p><div id=' .
		'"tt_write_tweet_result" style="margin-bottom:5px;"></div>' .
		'<div id="tt_schedule_tweet_result" style="margin-bottom:' .
		'5px;"></div><div id="tt_shorten_urls_result"></div>' .
		'</fieldset>';
	if(function_exists('wp_nonce_field'))
		wp_nonce_field('tt_new_tweet', '_wpnonce', true, false);
	if(function_exists('wp_referer_field')) wp_referer_field(false);
	echo	'<div id="tt_tweet_notes" style="border:2px solid ' .
		'#00b6bf;background-color:#e6fffe;padding:0 10px 0 10px;' .
		'margin-left:6px;margin-top:15px;width:750px;">';
		$get_service = tt_option('tt_admin_url_service');
	if($get_service == 'same') $get_service = tt_option('tt_url_service');
	if($get_service == '' || $get_service == 'same' ||
		$get_service == 'local' || ($get_service == 'adjix' &&
		tt_option('tt_adjix_api_key') == '') ||
		($get_service == 'snipurl' &&
		(tt_option('tt_snipurl_username') == '' ||
		tt_option('tt_snipurl_api_key') == '')))
			$service = 'bit.ly';
	else	$service = $get_service;
	if(($get_service == 'adjix' && $service == 'bit.ly') ||
		($get_service == 'snipurl' && $service == 'bit.ly'))
			$notice = ', ' . __('because your chosen URL ' .
			'service requires an API key which you have not ' .
			'provided in the Tweet This options', 'tweet-this');
	if($service == 'custom')
		$service = __('your custom URL service', 'tweet-this');
	else	$service = ucfirst($service);
	global $wpdb;
	printf(__('<p>Congratulations! This page only appears if you have ' .
		'entered your OAuth keys.</p>' .
		'<p>URLs will be shortened with <strong>%3$s</strong> if ' .
		'your tweet is over 140 characters%4$s. You can update URL ' .
		'services <a target="_blank" href="%1$s/wp-admin/options-' .
		'general.php%5$s">here</a>.</p>' .
		'<p>Click "Preview This" to see exactly what will be ' .
		'published to your Twitter account with an accurate ' .
		'character count.</p>' .
		'<p>Click "Schedule This" to schedule the tweet for the ' .
		'date specified in the box to the right. This defaults to ' .
		'one hour after you loaded this page. Make sure to use ' .
		'"YYYY-MM-DD&nbsp;HH:mm:SS" format. If you have not used ' .
		'tweet scheduling before, a table named `%2$s` will be ' .
		'created in your database.</p>' .
		'<p>An HTTP 401 error indicates incorrect OAuth keys. An ' .
		'HTTP 403 error can mean that you have exceeded 140 ' .
		'characters or that you are trying to publish a duplicate ' .
		'tweet. <a target="_blank" href="http://apiwiki.twitter.com/' .
		'HTTP-Response-Codes-and-Errors">Click here</a> for more ' .
		'information on HTTP response codes.</p>' .
		'<p>Note that scheduled tweets will be triggered up to ten ' .
		'minutes AFTER the scheduled time, and then only posted ' .
		'when someone loads a page on your blog. The last 100 ' .
		'scheduled tweets will be listed below from newest to ' .
		'oldest in order of date scheduled. You will have to reload ' .
		'the page to update the list. <strong>To cancel a scheduled ' .
		'tweet, you must log on to phpMyAdmin and delete the tweet ' .
		'from the `%2$s` table</strong>. There is no way to delete ' .
		'or edit scheduled tweets from here, though I am working on ' .
		'that feature. "Status" shows "future" for scheduled ' .
		'tweets, "publish" for successfully published tweets, and ' .
		'"fail" for scheduled tweets that could not be published.</p>',
		'tweet-this'), get_bloginfo('url'), $wpdb->rxtt, $service,
		$notice, constant('TT_FILE_LOC'));
	echo	'</div>'; global $wpdb;
	$tweets = $wpdb->get_col("SELECT ID FROM $wpdb->rxtt ORDER BY tt_date
		DESC LIMIT 100");
	if($tweets) {
		echo '<div id="tt_scheduled_tweets" style="border:2px solid ' .
		'#b6bf00;background-color:#fffee6;padding:5px;margin-top:' .
		'15px;margin-bottom:15px;margin-left:6px;width:760px;">' .
		'<table border="3" cellspacing="3" cellpadding="3"><tr><td>' .
		'<strong><u>' . __('ID', 'tweet-this') . '</u></strong>' .
		'&nbsp;</td><td>&nbsp;<strong><u>' . __('Scheduled Date',
		'tweet-this') . '</u></strong>&nbsp;&nbsp;</td><td>&nbsp;' .
		'&nbsp;<strong><u>' . __('Tweet Text', 'tweet-this') .
		'</u></strong>&nbsp;&nbsp;</td><td>&nbsp;&nbsp;<strong><u>' .
		__('Status', 'tweet-this') . '</u></strong></td></tr>';
		foreach($tweets as $tweet) {
			$content = $wpdb->get_row("SELECT * FROM $wpdb->rxtt
				WHERE ID = '$tweet' LIMIT 1");
			echo	'<tr><td><strong>' . $content->ID .
				'</strong>' . '&nbsp;</td><td>&nbsp;<strong>' .
				str_replace(' ', '&nbsp;&nbsp;',
				$content->tt_date) . '</strong>&nbsp;&nbsp;' .
				'</td><td>' .
				htmlentities($content->tt_content) . '&nbsp;' .
				'&nbsp;</td><td>&nbsp;&nbsp;<strong>' .
				$content->tt_status . '</strong></td></tr>';}
		echo	'</table></div>';}
	echo	'</form>';
}


/**
 * Prints the options form and updates the options.
 */
function tweet_this_options() {
	$show_form = 'true';
	if(isset($_REQUEST['submit']))
		update_tt_options();
	elseif(isset($_REQUEST['reset'])) {
		delete_option('tweet_this_settings');
		global_flush_tt_cache();
		tweet_this_install();
	    // Resettting the options requires a page refresh on WP 1.5.
		if(version_compare($GLOBALS['wp_version'], '2.0', '<')) {
			update_option('tweet_this_import_key', 'reset2');
			echo	'<br /><div id="message" class="updated fade">
				<p>' . __('Resetting Tweet This options. ' .
				'Please wait...', 'tweet-this') . '</p></div>
				<meta http-equiv="refresh" content="0">';
			$show_form = 'false';
		}
	}
	elseif(get_option('tweet_this_import_key') == 'reset2') {
		update_option('tweet_this_import_key', 'reset1');
		echo	'<br /><div id="message" class="updated fade"><p>' .
			__('Tweet This options reset successfully. URL ' .
			'cache flushed.', 'tweet-this') . '</p></div>';
	}
	elseif(isset($_REQUEST['import'])) {
		global $wpdb;
		$import_options = $_POST['import_content'];
		if(substr($import_options, 0, 1) == 'a') {
			$wpdb->query("UPDATE $wpdb->options SET option_value =
				'$import_options' WHERE option_name =
				'tweet_this_settings'");
				if(function_exists('wp_cache_flush'))
					wp_cache_flush();
				global_flush_tt_cache();
			echo	'<br /><div id="message" class="updated fade">
				<p>' . __('Tweet This options imported ' .
				'successfully. URL cache flushed.',
				'tweet-this') . '</p></div>';
			}
		else echo	'<br /><div id="message" class="error">
				<p>' . __('There is something wrong with the' .
				' provided options. Import aborted.',
				'tweet-this') . '</p></div>';
	}
	if($show_form != 'false')
		print_tt_form();
}


/**
 * Sets one cached URL to "getnew". get_tweet_this_short_url() regenerates
 * the shortened URL based on the the user's settings. This is used when
 * the user edits a post or changes permalinks.
 */
function flush_tt_cache($post_id) {
	update_post_meta($post_id, 'tweet_this_url', 'getnew');
}


/**
 * Deletes a cached URL.
 */
function delete_tt_cache() {
	global $id;
	delete_post_meta($id, 'tweet_this_url');
}


/**
 * Sets every shortened URL in the database to "getnew", triggering a reindex
 * the first time each post is viewed again. This is used when you change
 * permalink structures or URL services, since the old URLs can no longer be
 * trusted. Meta keys are reused to prevent artifical inflation of ID counter.
 */
function global_flush_tt_cache() {
	global $wpdb;
	$wpdb->query("UPDATE $wpdb->postmeta SET meta_value = 'getnew' WHERE
		meta_key = 'tweet_this_url'");
}


/**
 * Deletes every cached URL upon deactivating the plugin.
 */
function global_delete_tt_cache() {
	global $wpdb;
	$wpdb->query("DELETE FROM $wpdb->postmeta " .
		"WHERE meta_key = 'tweet_this_url'");
	delete_option('tweet_this_import_key');
}


/**
 * Deletes all Tweet This postmeta for a post.
 */
function delete_tt_postmeta() {
	global $id;
	delete_post_meta($id, 'tt_auto_tweet');
	delete_post_meta($id, 'tt_auto_tweet_text');
	delete_post_meta($id, 'tt_http_code');
	delete_post_meta($id, 'tt_tweeted');
	delete_post_meta($id, 'tweet_this_url');
}


/**
 * Loads the textdomain and publishes scheduled tweets every ten minutes.
 */
function tweet_this_init() {
	if(function_exists('load_plugin_textdomain')) {
		if(version_compare($GLOBALS['wp_version'], '2.6', '<'))
			load_plugin_textdomain('tweet-this',
				'wp-content/plugins/' . TT_DIR . '/languages');
		else load_plugin_textdomain('tweet-this', false,
			TT_DIR . '/languages');
	}
	if(get_option('tweet_this_db_version') == '1.0') {
		global $wpdb;
		$last = get_option('tweet_this_last_cron', false);
		if(($last != false && $last > (time() - 600)) ||
		tt_option('tt_app_consumer_key') == '' ||
		tt_option('tt_app_consumer_secret') == '' ||
		tt_option('tt_oauth_token') == '' ||
		tt_option('tt_oauth_token_secret') == '')
			return;
		update_option('tweet_this_last_cron', time());
		$pending = $wpdb->get_col("SELECT ID FROM $wpdb->rxtt WHERE
			(tt_date > 0 && tt_date <= CURRENT_TIMESTAMP() AND
			tt_status = 'future')");
		if(!count($pending)) return; 
		foreach($pending as $post){
			if(!$post) continue;
			$content = $wpdb->get_row("SELECT * FROM $wpdb->rxtt
				WHERE ID = '$post' LIMIT 1");
			$connection = tt_oauth_connection();
			$connection->decode_json = true;
			$data = $connection->post(TT_API_POST_STATUS,
				array('status' => $content->tt_content,
				'source' => 'tweetthis'));
			if($connection->http_code == '200') {
				$status = 'publish';
				$response = $data->id;}
			else {	$status = 'fail';
				$response = $connection->http_code;}
			$wpdb->update($wpdb->rxtt, array('tt_status' =>
				$status, 'tt_response' => $response),
				array('ID' => $post, 'tt_status' => 'future'));
		}
	}
}


/**
 * Return the cached URL or a local URL for a post or page.
 */
function get_tt_shortlink($post_id = '') {
	if($post_id == '') {global $post; $post_id = $post->ID;}
	if($post_id != '') {
		$get_cache = get_post_meta($post_id, 'tweet_this_url', true);
		if(trim($get_cache) != '' && $get_cache != 'getnew')
			$cache = $get_cache;
		else $cache = get_tweet_this_short_url(
			get_permalink($post_id), $post_id, true);
		return $cache;}
	else return false;
}


/**
 * Echoes the above function for convenience.
 */
function tt_shortlink($post_id = '') {
	if($post_id == '') {global $post; $post_id = $post->ID;}
	if($post_id != '') echo get_tt_shortlink($post_id);
	else return false;
}


/**
 * Return the cached URL or a local URL for insertion into wp_head.
 */
function get_tt_shortlink_wp_head($post_id = '') {
	if($post_id == '') {global $post; $post_id = $post->ID;}
	if($post_id != '') return '<link rel="shortlink" href="' .
		get_tt_shortlink($post_id) . '" />';
	else return false;	
}


/**
 * Echoes the above function for convenience.
 */
function tt_shortlink_wp_head($post_id = '') {
	if($post_id == '') {global $post; $post_id = $post->ID;}
	if($post_id != '') echo get_tt_shortlink_wp_head($post_id);
	else return false;
}


/**
 * Used if "Insert Tweet This message in footer" checked in Advanced Options.
 */
function tweet_this_footer() {
	echo	'<div style="width:738px;margin:10px auto 10px auto;">
		<p style="text-align:center;">';
	printf(__('Twitter links powered by <a target="_blank" href="http://' .
		'richardxthripp.thripp.com/tweet-this/">Tweet This v%1$s' .
		'</a>, a WordPress plugin for Twitter.', 'tweet-this'),
		TT_VERSION); echo '</p></div>';
}


/**
 * Inserts ad below each single post if "Insert Google AdSense ads to support
 * Tweet This" is checked in Advanced Options. This made me $75 in August 2010.
 */
function tweet_this_ad_body($content) {
	if(is_singular())
		return $content .= '<p><script type="text/javascript">
			google_ad_client = "pub-5149869439810473";
			google_ad_slot = "1830968079";
			google_ad_width = 336;
			google_ad_height = 280;
			</script>
			<script type="text/javascript" ' .
			'src="http://pagead2.googlesyndication.com/pagead/' .
			'show_ads.js"></script></p>';
}


/**
 * An ad is also inserted into the footer if the ads option is checked.
 */
function tweet_this_ad_footer() {
	echo	'<div style="width:738px;margin:auto;"><p>
		<script type="text/javascript">
		google_ad_client = "pub-5149869439810473";
		google_ad_slot = "6830530578";
		google_ad_width = 728;
		google_ad_height = 90;
		</script>
		<script type="text/javascript" ' .
		'src="http://pagead2.googlesyndication.com/pagead/' .
		'show_ads.js"></script></p></div>';
}


/**
 * Converts an absolute date to a relative date.
 * Based on: http://wordpress.org/extend/plugins/wickett-twitter-widget/
 * Wickett Twitter Widget  Copyright 2009  Automattic Inc.
 */
function tt_relative_time($original, $do_more = 0) {
	$chunks = array(array(31536000, 'year'), array(2592000, 'month'),
		array(604800, 'week'), array(86400, 'day'),
		array(3600, 'hour'), array(60, 'minute'));
	$since = time() - $original;
	for($i = 0, $j = count($chunks); $i < $j; $i++) {
		$seconds = $chunks[$i][0];
		$name = $chunks[$i][1];
		if(($count = floor($since / $seconds)) != 0) break;}
	$print = ($count == 1) ? '1 ' . $name : "$count {$name}s";
	if($i + 1 < $j) {
		$seconds2 = $chunks[$i + 1][0];
		$name2 = $chunks[$i + 1][1];
		if((($count2 = floor(($since - ($seconds * $count)) /
		$seconds2)) != 0) && $do_more)
			$print .= ($count2 == 1) ? ', 1 ' . $name2 :
			", $count2 {$name2}s";}
	return $print;
}


/**
 * Adds a Tweet This widget to Appearance > Widgets in WP 2.8 or later.
 * Based on: http://wordpress.org/extend/plugins/wickett-twitter-widget/
 * Wickett Twitter Widget  Copyright 2009  Automattic Inc.
 */
if(version_compare($wp_version, '2.7.9', '>')) :
class Tweet_This_Widget extends WP_Widget {
	function Tweet_This_Widget() {
		$widget_ops = array('classname' => 'tweet_this_widget',
			'description' => __('Displays your latest Twitter ' .
			'updates. Part of the Tweet This plugin.',
			'tweet-this'));
		$this->WP_Widget('tweet-this', __('Twitter Updates',
			'tweet-this'), $widget_ops);}
	function widget($args, $instance) {
		extract($args);
		$account = urlencode($instance['account']);
		if(empty($account)) return;
		$title = apply_filters('widget_title', $instance['title']);
		if(empty($title)) $title = __('Twitter Updates', 'tweet-this');
		$show = absint($instance['show']);
		$hidereplies = $instance['hidereplies'];
		$before_timesince = esc_html($instance['beforetimesince']);
		if(empty($before_timesince)) $before_timesince = ' ';
		$before_tweet = esc_html($instance['beforetweet']);
		echo	$before_widget . $before_title . '<a href="' .
			clean_url('http://twitter.com/' . $account) .
			'" target="_blank">' . $title . '</a>' . $after_title;
		if(!$tweets = wp_cache_get('tweet-this-widget-' .
		$this->number, 'widget')) {
			$twitter_json_url = clean_url("http://twitter.com/" .
			"statuses/user_timeline/$account.json", null, 'raw');
			$response = wp_remote_get($twitter_json_url,
				array('User-Agent' => 'Tweet This'));
			$response_code =
				wp_remote_retrieve_response_code($response);
			if($response_code == 200) {
				$tweets = wp_remote_retrieve_body($response);
				$tweets = json_decode($tweets);
				$expire = 900;
				if(!is_array($tweets) ||
				isset($tweets['error'])) {
					$tweets = 'error'; $expire = 300;}}
			else {	$tweets = 'error'; $expire = 300;
				wp_cache_add('tweet-this-widget-response-' .
					'code-' . $this->number,
					$response_code, 'widget', $expire);}
			wp_cache_add('tweet-this-widget' . $this->number,
				$tweets, 'widget', $expire);}
		if($tweets != 'error') {
			echo '<ul class="tweets">';
			$tweets_out = 0;
			foreach((array) $tweets as $tweet) {
			if($tweets_out >= $show) break;
			if(empty($tweet->text) || ($hidereplies &&
			!empty($tweet->in_reply_to_user_id))) continue;
			$text = preg_replace_callback('/(^|\s)#(\w+)/',
				array($this, '_tweet_this_widget_hashtag'),
				preg_replace_callback('/(^|\s)@(\w+)/',
				array($this, '_tweet_this_widget_username'),
			make_clickable(wp_specialchars($tweet->text))));
			$created_at = substr($tweet->created_at, 0, 10) .
				substr($tweet->created_at, 25, 5) .
				substr($tweet->created_at, 10, 15);
			echo	'<li>' . $before_tweet . $text .
				$before_timesince . '<a href="' .
				clean_url('http://twitter.com/' . $account .
				'/statuses/' . urlencode($tweet->id)) .
				'" class="timesince" target="_blank">' .
				str_replace(' ', '&nbsp;',
				tt_relative_time(strtotime($created_at))) .
				'&nbsp;ago</a></li>';
			$tweets_out++;} echo '</ul>';}
		else {	if(wp_cache_get('tweet-this-widget-response-code-' .
				$this->number, 'widget') == 401) echo '<p>' .
				__('HTTP 401 Error: Please make sure the ' .
				'Twitter account is <a href="http://help.' .
				'twitter.com/forums/10711/entries/14016" ' .
				'target="_blank">public</a>.', 'tweet-this') .
				'</p>';
			else echo '<p>' . __('Error: Twitter did not ' .
				'respond. Please wait a few minutes and ' .
				'refresh this page.', 'tweet-this') . '</p>';}
		echo $after_widget;}
	function update($new_instance, $old_instance) {
		$instance = $old_instance;
		$instance['account'] =
			strip_tags(stripslashes($new_instance['account']));
		$instance['account'] = str_replace('http://twitter.com/', '',
			$instance['account']);
		$instance['account'] = str_replace('/', '',
			$instance['account']);
		$instance['account'] = str_replace('@', '',
			$instance['account']);
		$instance['title'] =
			strip_tags(stripslashes($new_instance['title']));
		$instance['show'] = absint($new_instance['show']);
		$instance['hidereplies'] = isset($new_instance['hidereplies']);
		$instance['beforetimesince'] =
			$new_instance['beforetimesince'];
		wp_cache_delete('tweet-this-widget-' . $this->number,
			'widget');
		wp_cache_delete('tweet-this-widget-response-code-' .
			$this->number, 'widget');
		return $instance;}
	function form($instance) {
		$instance = wp_parse_args((array)$instance, array('account' =>
			'', 'title' => __('Twitter Updates', 'tweet-this'),
			'show' => '3', 'hidereplies' => false));
		$account = esc_attr($instance['account']);
		$title = esc_attr($instance['title']);
		$show = absint($instance['show']);
		if($show < 1 || 20 < $show) $show = '3';
		$hidereplies = (bool)$instance['hidereplies'];
		$before_timesince = esc_attr($instance['beforetimesince']);
		echo	'<p><label for="' . $this->get_field_id('title') .
			'">' . __('Title:', 'tweet-this') . '<input class=' .
			'"widefat" id="' . $this->get_field_id('title') .
			'" name="' . $this->get_field_name('title') .
			'" type="text" value="' . $title . '" /></label></p>' .
			'<p><label for="' . $this->get_field_id('account') .
			'">' . __('Twitter username:', 'tweet-this') .
			'<input class="widefat" id="' .
			$this->get_field_id('account') . '" name="' .
			$this->get_field_name('account') . '" type="text" ' .
			'value="' . $account . '" /></label></p><p><label ' .
			'for="' . $this->get_field_id('show') . '">' .
			__('Show latest ', 'tweet-this') .
			'<select id="' . $this->get_field_id('show') .
			'" name="' . $this->get_field_name('show') . '">';
		for($i = 1; $i <= 20; ++$i)
			echo	'<option value="' . $i . '"' .
				($show == $i ? ' selected="selected"' : '') .
				'>' . $i . '&nbsp;</option>';
		echo	'</select> ' . __('tweets', 'tweet-this') .
			'</label></p><p><label for="' .
			$this->get_field_id('hidereplies') . '"><input id="' .
			$this->get_field_id('hidereplies') . '" class=' .
			'"checkbox" type="checkbox" name="' .
			$this->get_field_name('hidereplies') . '"' .
			checked($hidereplies) . ' /> ' . __('Hide replies',
			'tweet-this') . ' </label></p><p><label for="' .
			$this->get_field_id('beforetimesince') . '">' .
			__('Text between tweet and time:', 'tweet-this') .
			'<input class="widefat" id="' .
			$this->get_field_id('beforetimesince') . '" name="' .
			$this->get_field_name('beforetimesince') . '" type=' .
			'"text" value="' . $before_timesince . '" /></label>' .
			'</p>';}
	function _tweet_this_widget_username($matches) {
		return $matches[1] . '@<a href="' .
		clean_url('http://twitter.com/' . urlencode($matches[2])) .
		'" target="_blank">' . $matches[2] . '</a>';}
	function _tweet_this_widget_hashtag( $matches ) {
		return $matches[1] . '<a href="' .
		clean_url('http://search.twitter.com/search?q=%23' .
		urlencode($matches[2])) . '" target="_blank">#' . $matches[2] .
		'</a>';}
} endif;


/**
 * Initializes the Tweet This widget in WP 2.8 or later.
 */
function tweet_this_widget_init() {
	if(function_exists('register_widget') &&
	class_exists('Tweet_This_Widget'))
		register_widget('Tweet_This_Widget');
}


/**
 * Actions for updating the database, tweeting posts, and displaying things.
 */
add_action('init', 'tweet_this_init');
add_action('init', 'tt_request_handler');
add_action('publish_post', 'flush_tt_cache');
add_action('save_post', 'flush_tt_cache');
add_action('delete_post', 'delete_tt_postmeta');
add_action('generate_rewrite_rules', 'global_flush_tt_cache');
add_action('draft_post', 'tt_store_post_options', 1, 2);
add_action('save_post', 'tt_store_post_options', 1, 2);
add_action('publish_post', 'tt_store_post_options', 1, 2);
add_action('publish_post', 'tt_auto_tweet', 99);
add_action('publish_page', 'tt_auto_tweet', 99);
add_filter('the_content', 'insert_tweet_this');
if(tt_option('tt_auto_tweet_display') != 'false')
	add_action('edit_form_advanced', 'tt_post_options');
if(tt_option('tt_auto_tweet_display_pages') != 'false')
	add_action('edit_page_form', 'tt_post_options');
if(TT_HIDE_MENU != true)
	add_action('admin_menu', 'tweet_this_add_options');
if(tt_option('tt_css') != '[BLANK]')
	add_action('wp_head', 'get_tweet_this_css');
remove_action('wp_head', 'wp_shortlink_wp_head', 10, 0);
if(tt_option('tt_footer') == 'true')
	add_action('wp_footer', 'tweet_this_footer');
if(tt_option('tt_ads') == 'true') {
	add_action('the_content', 'tweet_this_ad_body');
	add_action('wp_footer', 'tweet_this_ad_footer');}
if(tt_option('tt_shortlink_filter') != 'false' && tt_option('tt_url_service')
	!= 'local' && tt_option('tt_url_service') != '') {
	if(version_compare($wp_version, '2.5', '<') ||
	(function_exists('has_action') &&
	!has_action('wp_head', 'wp_shortlink_wp_head')))
		add_action('wp_head', 'tt_shortlink_wp_head');
	if(version_compare($wp_version, '2.9.9', '>'))
		add_filter('get_shortlink', 'get_tt_shortlink');}
if(version_compare($wp_version, '2.7.9', '>'))
	add_action('widgets_init', 'tweet_this_widget_init');


/**
 * Activation / deactivation hooks.
 */
if(function_exists('register_activation_hook'))
	register_activation_hook(__FILE__, 'tweet_this_install');
else add_action('activate_' . __FILE__, 'tweet_this_install');
if(function_exists('register_deactivation_hook'))
	register_deactivation_hook(__FILE__, 'global_delete_tt_cache');
else add_action('deactivate_' . __FILE__, 'global_delete_tt_cache');

?>